// FILENAME:	C&D_Avalanche.cs
//
// AUTHOR:  	Gen. Raven [M.I.B.]
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection
$server::HudMapViewOffsetX = 500; 
$server::HudMapViewOffsetY = 3500; 

//------------------------------------------------------------------------------
$missionName = "C&D Into The Light";

function remoteHoverSwitch(%player){ }

function remoteCancelSwitch(%player){ }

function remoteForwardSwitch(%player){ }

function remoteBoostSwitch(%player){ }

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;  
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

$antiSpawnKill = true; //Anti-Spawnkill option for teamplay
                       //Players are invincible for 10 seconds after spawning

$antiSpawnKillProx = true; //Cant hit prox mines until 10 seconds after spawn.
                           //If true...the above MUST also be set to true                           

$initScarps = 40; //Amount of scarps each player starts with
$lastKSAT = "";

if(($antiSpawnKillProx==true)&&($antispawnkill==false))
{
   $antiSpawnKill = true;
   echo("You have to have antispawnkill on for antispawnkillprox to work!");
}

Pilot Generic
{
   name = "Cybrid";
   id = 28;
   skill = 1.0;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 500.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Elite
{
   name = "Cybrid";
   id = 29;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 550.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Ghost1
{
   name = "Jehrico";
   id = 51;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 600.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost2
{
   name = "Razorback";
   id = 52;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 650.0;
   deactivateBuff = 100.0;
   targetFreq = 1.5;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost3
{
   name = "Altas";
   id = 53;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 700.0;
   deactivateBuff = 100.0;
   targetFreq = 2.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost4
{
   name = "Ko'ah";
   id = 54;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 750.0;
   deactivateBuff = 100.0;
   targetFreq = 2.5;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost5
{
   name = "Tycho";
   id = 55;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 800.0;
   deactivateBuff = 100.0;
   targetFreq = 3.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost6
{
   name = "Xenogears";
   id = 56;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 850.0;
   deactivateBuff = 100.0;
   targetFreq = 3.5;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost7
{
   name = "Icey";
   id = 57;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 900.0;
   deactivateBuff = 100.0;
   targetFreq = 4.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost8
{
   name = "Delithita";
   id = 58;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 950.0;
   deactivateBuff = 100.0;
   targetFreq = 4.5;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
Pilot Ghost9
{
   name = "Maria";
   id = 59;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 1000.0;
   deactivateBuff = 100.0;
   targetFreq = 5.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};
function onMissionStart()
{
   earthquakeSounds();
   $pkg = 0;
   $gkp = 0;
   $turHATC = getObjectId("MissionGroup\\OrigTurrets\\tur0");
   $turHLAS = getObjectId("MissionGroup\\OrigTurrets\\tur2");
   $turHBC = getObjectId("MissionGroup\\OrigTurrets\\tur4");
   $turELF = getObjectId("MissionGroup\\OrigTurrets\\tur6");
   $turNIKE = getObjectId("MissionGroup\\OrigTurrets\\tur8");
   $tursiren = getObjectId("MissionGroup\\OrigTurrets\\tur10");
   $itemZen = getObjectId("MissionGroup\\ItemGroup\\Zen");
   $itemHeal = getObjectId("MissionGroup\\ItemGroup\\HealTrig");
   $itemAmmo = getObjectId("MissionGroup\\ItemGroup\\Ammo");
   $itemProx = getObjectId("MissionGroup\\ItemGroup\\Prox");
   $itemMine = getObjectId("MissionGroup\\ItemGroup\\mine");
   $itemField = getObjectId("MissionGroup\\ItemGroup\\Field");
   $itemWave = getObjectId("MissionGroup\\ItemGroup\\Wave");
   $itemSiren = getObjectId("MissionGroup\\ItemGroup\\siren");
   $itemmarker = getObjectId("MissionGroup\\ItemGroup\\marker1");
   $itemStasis = getObjectId("MissionGroup\\ItemGroup\\Stasis");
   $ksatBeam = getObjectId("MissionGroup\\ItemGroup\\ksatBeam");
   $navYellow = getObjectId("MissionGroup\\YellowBase\\navYellow");
   $navBlue = getObjectId("MissionGroup\\BlueBase\\navBlue");
   $navRed = getObjectId("MissionGroup\\RedBase\\navRed");
   $navPurple = getObjectId("MissionGroup\\PurpleBase\\navPurple");
   storeobject("MissionGroup\\Ghosts\\merc", "merc.gse");
   deleteobject("MissionGroup\\Ghosts\\merc");
   storeobject("MissionGroup\\Ghosts\\deli", "deli.gse");
   deleteobject("MissionGroup\\Ghosts\\deli");
   storeobject("MissionGroup\\Ghosts\\icey", "icey.gse");
   deleteobject("MissionGroup\\Ghosts\\icey");
   storeobject("MissionGroup\\Ghosts\\xeno", "xeno.gse");
   deleteobject("MissionGroup\\Ghosts\\xeno");
   storeobject("MissionGroup\\Ghosts\\tych", "tych.gse");
   deleteobject("MissionGroup\\Ghosts\\tych");
   storeobject("MissionGroup\\Ghosts\\koah", "koah.gse");
   deleteobject("MissionGroup\\Ghosts\\koah");
   storeobject("MissionGroup\\Ghosts\\alta", "alta.gse");
   deleteobject("MissionGroup\\Ghosts\\alta");
   storeobject("MissionGroup\\Ghosts\\raza", "raza.gse");
   deleteobject("MissionGroup\\Ghosts\\raza");
   storeobject("MissionGroup\\Ghosts\\jehr", "jehr.gse");
   deleteobject("MissionGroup\\Ghosts\\jehr");
   $glitchcount = 9;
   storeanddeletecybrids();
   schedule("cleanUpDeadTurrets();",300);
   $whichnav = 1;

   if(($server::TimeLimit != "")&&($server::TimeLimit > 5))
   {
      %time = ($server::timelimit - 5) * 60; 
      schedule("fiveMinuteWarning();", %time);
   }
}

function storeanddeletecybrids(){
 storeobject("MissionGroup\\cybrids\\"@$glitchcount, "cybrid"@$glitchcount@".gse");
 deleteobject("MissionGroup\\cybrids\\"@$glitchcount);
 $glitchcount = $glitchcount - 1;
 if($glitchcount != 0){ schedule("storeanddeletecybrids();", 0.1); }
 else{ activateCybrids(); } }

function activateCybrids(){
 %veh = loadobject( "glitch", "cybrid"@$glitchcount@".gse" );
 setposition(%veh, randomint(0, 4000), randomint(1000, 2000), 500);
 setpilotid(%veh, 29);
 %veh.isGlitch = true;
 order(%veh, guard, "MissionGroup/cybpath");
 addtoset("MissionGroup/cybrids", %veh);
 $glitchcount++;
 if($glitchcount != 10){ schedule("activatecybrids();", 0.1); } }

function fiveMinuteWarning()
{
   say(0,20,"<jc><f5>WARNING: Mission ends in 5 minutes.<n>Scarps not spent will be lost.","sfx_siren.wav");
}

function onMissionLoad()
{
   cdAudioCycle("Mechsoul", "CloudBurst", "Terror", "Watching", "Cyberntx");
   setGameInfo("<f2>GAME TYPE:<f0>  Command & Destroy\n\n<f2>CREATOR:<f0>  Gen. Raven [M.I.B.]\n\n<f0>Each player begins with "@$initScarps@" scarps. Earn more scarps by destroying enemy vehicles and turrets. Then scan the target drone balls at each base or use the HercBoost keymap to select and purchase vehicles, turrets, and other useful items. When you purchase an item, you will recieve information on the full use of that item. \n\n<f2>This map was created by the Tarazedi Alliance Mapper's Craft.  Download C&D and other maps from www.tarazedi.com and www.sunandshadows.com/mib.");
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getPlayerNum(%i);
      if(%player.group=="")
      {  
         %player.aicount = 0;
         %player.invincible = false;
         %player.extraKills = 0;
         %player.deathdelay = false;
         %player.delay = false;
         %player.scarps = $initScarps;
         %player.item = "Reload";
         %player.hasItem = false;
         %player.currentitem = "";
         %player.veh = "Seek";
         %player.turret = "A";
         %player.category = "veh";
         %player.attackDelay = false;
         %player.group = newObject("group"@%player, simGroup);
         addToSet("Missiongroup", %player.group);
         %player.turgroup = newObject("GroupOfTurrets", simGroup);
         addToSet(%player.group, %player.turgroup);    
      }
   }
}

function player::onAdd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
   say(%player, 0, "Welcome to Command & Destroy (C&D) by Raven.  In this gametype you earn scarps (credits) for destroying enemies and can use them to buy your own vehicles and special items.  This map was created by the Tarazedi Alliance Mapper's Craft.  Go to sunandshadows.com/mib and tarazedi.com for more great maps.");
  
   %player.aicount = 0;
   %player.invincible = false;
   %player.extraKills = 0;
   %player.delay = false;
   %player.deathdelay = false;
   %player.scarps = $initScarps;
   %player.item = "Reload";
   %player.hasItem = false;
   %player.currentitem = "";
   %player.veh = "Seek";
   %player.turret = "EH";
   %player.category = "veh";
   %player.attackDelay = false;
   deleteObject(%player.group);
   %player.group = newObject("group"@%player, simGroup);
   addToSet("Missiongroup", %player.group);
   %player.turgroup = newObject("GroupOfTurrets", simGroup);
   addToSet(%player.group, %player.turgroup);
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
   echo(%player.group@" GROUP"@%player@" deleted");
   deleteObject(%player.group);
   %player.group = "";
}

function copyObject(%object,%name)
{
   storeObject(%object, "copyObject.tmp");
   if(%name=="")
   {
      %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   }
   else
   {
      %copy = loadObject(%name, "copyObject.tmp");
   }
   return %copy;
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleidtoplayernum(%vehicleId);
   if(%player!=0)
   {
      if(getteam(%vehicleID) == IDSTR_TEAM_PURPLE){ setTeam(%vehicleID, *IDSTR_TEAM_YELLOW); }
      %vehicleId.owner = "";
      %player.delay = false;      
      %player.InPad = false;
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      %obj = getNextObject(%player.group,0);
      while(%obj!=0)
      {
         if((getTeam(%player)!=%player.lastteam)&&(getobjectname(%obj)=="veh"))
         {
            setPosition(%obj,5000,5000,-5000);
            setTeam(%obj, getTeam(%player));
            schedule("randomTransport("@%obj@",getPosition("@%vehicleid@",x)-300,getPosition("@%vehicleid@",y)-300,getPosition("@%vehicleid@",x)+300,getPosition("@%vehicleid@",y)+300);",1);
         }
         %obj = getNextObject(%player.group,%obj);
      }
      order("MissionGroup\\group"@%player, guard, %vehicleId);
      reloadObject("MissionGroup\\group"@%player, 5000);
      %player.lastteam = getTeam(%player);
   }
   %vehicleId.hitamine = false;
   if((%player!=0)&&($server::teamplay==true)&&($antiSpawnKill==true))
   {
      %player.invincible = true;
      schedule("resetInvincible("@%player@");",10);      
   }
}

function resetInvincible(%player)
{
   // Player shouldnt be able to die from enemy fire...
   // so this will work correctly unless a player respawns 
   // within 10 secs of spawning.
   %player.invincible = false;
   playSound(%player,"C2_tattadit.wav",IDPRF_2D);
   echo(getname(%player)@" is no longer invincible.");
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   if(%destroyed.isGlitch == true){
    $pkg++;
    if(%destroyed.rand2 == ""){ %destroyed.rand2 = randomInt(0,999); }
    say(0,0,getHudName(%destroyer)@" has killed "@getvehiclename(%destroyed)@"-"@%destroyed.rand2@". Humans have killed "@$pkg@" Cybrids.");
    glitchDie(%destroyed, %destroyer); }
   if(%destroyer.isGlitch == true){
    $gkp++;
    if(%destroyer.rand2 == ""){ %destroyer.rand2 = randomInt(0,999); }
    %percent = 100 * ($gkp / $pkg);
    %rand = randomInt(1,4);
    if(%rand == 1){ say(0,0,getVehicleName(%destroyer)@"-"@%destroyer.rand2@": Hurt//Maim//Kill. "@$gkp@" human//animals offlined.  Efficiency//Joy = "@%percent@" percent. "@getHudName(%destroyed), "C1_hurtmaimkill.WAV"); }
    else if(%rand == 2){ say(0,0,getVehicleName(%destroyer)@"-"@%destroyer.rand2@": Target executed. "@$gkp@" human//animals offlined.  Efficiency//Joy = "@%percent@" percent. "@getHudName(%destroyed), "C7_targetexec.WAV"); }
    else if(%rand == 3){ say(0,0,getVehicleName(%destroyer)@"-"@%destroyer.rand2@": MEAT deserves DEATH. "@$gkp@" human//animals offlined.  Efficiency//Joy = "@%percent@" percent. "@getHudName(%destroyed), "C1_meatdeath.WAV"); }
    else if(%rand == 4){ say(0,0,getVehicleName(%destroyer)@"-"@%destroyer.rand2@": VIOLENCE = STRENGTH. "@$gkp@" human//animals offlined.  Efficiency//Joy = "@%percent@" percent. "@getHudName(%destroyed), "C1_viloence.WAV"); } }
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   %player2.deathdelay = true;
   schedule("deathdelay(" @ %player2 @ ");", 5);
   if(%player2==0)
   {
      %him = %destroyed.owner;
      %him.aicount--;
   }
   if((%player!=0)&&(%destroyed!=%destroyer))
   {
      if(%destroyed.owner==%player)
      {
         say(%player,%player,"<f5>You do not recieve scarps for destroying your own AI vehicles.");
      }
      else
      {
         %name = getVehicleName(%destroyed);
         if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
         {
            %player.scarps += 8;
         }
         else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
         {
            %player.scarps += 6;
         }
         else
         {
            %player.scarps += 5;
         }
      }
   }
   if(%player2==0)
   {
      schedule("deleteObject("@%destroyed@");",2);
   }
   if((%player==0)&&(%destroyer.owner!="")&&(%destroyed.hitamine!=true)&&(%player2!=%destroyer.owner)&&(getTeam(%destroyer)!=getTeam(%destroyed)))
   {
      %owner = %destroyer.owner;
      %owner.extraKills++;
      %name = getVehicleName(%destroyed);
      if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
      {
         %owner.scarps += 8;
      }
      else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
      {
         %owner.scarps += 6;
      }
      else
      {
         %owner.scarps += 5;
      }
   }
   %ksatKill = false;
   if((%player==0)&&(%destroyer == -1)&&(%destroyed.hitamine!=true)&&(%player2!=$lastKSAT))
   {
      %owner = $lastKSAT;
      %name = getVehicleName(%destroyed);
      if(($server::teamplay==true)&&(getTeam(%owner)==getTeam(%destroyed)))
      {
         echo("KSAT TEAMKILL - No points awarded");
      }
      else if(%destroyed.owner==%owner)
      {
         echo("KSAT AI TEAMKILL - No points awarded");
      }
      else
      {
         %owner.extraKills++;
         if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
         {
            %owner.scarps += 8;
         }
         else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
         {
            %owner.scarps += 6;
         }
         else
         {
            %owner.scarps += 5;
         }
      }
      %ksatKill = true;
      say(0,0, getHudName(%destroyed)@" was killed by "@getName(%owner)@"'s Siren attack!");
   }
   else if((%player==0)&&(%destroyer == -1)&&(%destroyed.hitamine!=true)&&(%player2==$lastKSAT))
   {
      %ksatKill = true;
      say(0,0, getHudName(%destroyed)@" was killed by his own Siren attack!");
   }
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   if((%destroyed.hitamine!=true)&&(%ksatKill!=true)&&(%destroyer.isGlitch != true)&&(%destroyed.isGlitch != true))
   {
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
   }   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if((getTeam(%destroyed)==getTeam(%destroyer))&&(%destroyed!=%destroyer))
      {
         antiTeamKill(%destroyer);
      }
   }   
   %destroyed.owner = "";
   %destroyed.hitamine = false;   
}

function deathdelay(%player2)
{
   %player2.deathdelay = false;
}

function vehicle::onmessage(%destroyer,%message,%target)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if((%message=="TargetDestroyed")&&(strAlign(3,l,getObjectName(%target))=="tur"))
   {
      if(%target.owner!=%player)
      {
         %player.scarps+=5;
         %player.extraKills++;
      }
      %target.owner = "";
      schedule("deleteObject("@%target@");",2);
   }
}

function vehicle::onattacked(%attacked,%attacker)
{
   %p = playermanager::vehicleIdToPlayerNum(%attacked);
   if(%p.invincible==true)
   {
      healObject(%attacked,99999);
   }
   if(strAlign(3, l, getObjectName(%attacker)) != "tur")
   {
      %player = playermanager::vehicleIdtoPlayerNum(%attacker);
      %player2 = playermanager::vehicleIdtoPlayernum(%attacked);
      if((%player.attackdelay==false)&&(%attacked.owner==%player)&&(%player!=0)&&(%player2==0))
      {
         %player.attackdelay = true;
         say(%player,%player, "<f5>WARNING: You are firing upon your own vehicle!");
         schedule("resetAttack("@%player@");",3);   
      }
   }
}

function resetAttack(%player)
{
   %player.attackDelay = false;
}

function vehicle::onSpot(%spotter,%target)
{
   %player = playermanager::vehicleIdtoPlayerNum(%spotter);
   if(%target!="")
   {
      if((getTeam(%spotter)==getTeam(%target))&&($server::teamplay==true))
      {
         healObject(%spotter, -10000);
         say(%player,%player,"<f4>You cannot spot your teammates.","alarm2.wav");
      }
      else
      {
         order(%player.turgroup, attack, %target);
         say(%player,%player,"<f4>Your turrets have been ordered to attack "@getHudName(%target)@".");
      }
   }
   else
   {
      order(%player.turgroup, attack, 0);
      order(%player.turgroup, clear);
      say(%player,%player,"<f4>Target lost. You must maintain target lock.");
   }
}

function vehicle::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);
   %player2 = playermanager::vehicleidtoplayernum(%scanned);
   if((%player2==0)&&(%scanned.owner==%player))
   {
      order(%scanned,cloak,true);
      if(%scanned.order=="follow")
      {
         %nav = getVehicleNavMarkerId(%scanner);
         if(getPosition(%nav)=="0.000000 0.000000 0.000000")
         {
            say(%player,%player,"<f5>You must set a nav before you can order your AI vehicles.");
         }
         else
         {
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y);
            order(%scanned, guard, %x,%y,%z);
            %scanned.order = "guard";
            say(%player,%player,"<f4>Your AI vehicle is now guarding your nav marker.");
         }
      }
      else
      {
         order(%scanned,guard,%scanner);
         %scanned.order = "follow";
         say(%player,%player,"<f4>Your AI vehicle is now guarding your vehicle.");
      }
   }
   if(%scanned.owner!=%player)
   {
      if(%player.currentitem=="Stasis")
      {
         %player.hasitem = false;
         %field1 = copyObject($itemStasis);
         %field2 = copyObject($itemStasis);
         %field3 = copyObject($itemStasis);
         %field4 = copyObject($itemStasis);
         addToSet(%player.group,%field1);
         addToSet(%player.group,%field2);
         addToSet(%player.group,%field3);
         addToSet(%player.group,%field4);    
         %x = getposition(%scanned,x);
         %y = getposition(%scanned,y);
         %z1 = getTerrainHeight(%x,%y+30)+24;
         %z2 = getTerrainHeight(%x+30,%y)+24;
         %z3 = getTerrainHeight(%x,%y-30)+24;
         %z4 = getTerrainHeight(%x-30,%y)+24;
         setPosition(%field1,%x,%y+30,%z1,90,180);
         setPosition(%field2,%x+30,%y,%z2,0,180);
         setPosition(%field3,%x,%y-30,%z3,90,180);
         setPosition(%field4,%x-30,%y,%z4,0,180);
         say(%player,%player,"<f4>Stasis field deployed.","sfx_electrical_bzzt.wav");
         if(%player2!=0)
         {
            say(%player2,%player2,"<f4>Your vehicle has been temporarily trapped inside a stasis field.","sfx_electrical_bzzt.wav");
         }
         setHudTimer(0,-1,"",3,%player2);
         setHudTimer(60,-1,"Stasis Field:",3,%player2);
         schedule("deleteObject("@%field1@");",60);
         schedule("deleteObject("@%field2@");",60);
         schedule("deleteObject("@%field3@");",60);
         schedule("deleteObject("@%field4@");",60);
         %player.currentitem = "";
      }
      else if(%player.currentitem=="Ion")
      {
         %player.hasitem = false;
         %player.currentitem = "";
         %scannerX = getposition(%scanner,x);
         %scannerY = getposition(%scanner,y);
         %scannerZ = getposition(%scanner,z)+10;
         %scannedX = getposition(%scanned,x);
         %scannedY = getposition(%scanned,y);
         %scannedZ = getposition(%scanned,z);
         droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
         %distance = getdistance(%scanner,%scanned);
         %time = %distance / 400; //400 m/s (speed of drop pod)
         schedule("healObject("@%scanned@",-7500);",%time);
         if(%player2!=0)
         {
            schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
         }
         playSound(%player, "sfx_shrk.wav", IDPRF_2D);
      }
      else if(%player.currentitem=="Stun")
      {
         if(%player2==0)
         {
            say(%player,%player,"<f5>You cannot use this item on an AI vehicle.");
         }
         else
         {            
            %player.hasitem = false;
            %player.currentitem = "";
            playSound(%player,"sfx_cmd.wav",IDPRF_2D);
            say(%player2,%player2,"<f4>You have been hit with a stun grenade.","explo3.wav");
            fadeEvent(%player2,in,20,3,3,3);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",0.5);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",1);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",1.5);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",2);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",2.5);
            setVehicleSpecialIdentity(%scanned,true,"Yellow");
            schedule("setVehicleSpecialIdentity("@%scanned@",false);",22);
            %count = playermanager::getPlayerCount();
            for(%i = 0; %i < %count; %i++)
            {
               %player3 = playerManager::getPlayerNum(%i);
               %flashed = playerManager::playerNumToVehicleId(%player3);
               if((getDistance(%flashed, %scanned) <= 50) && (%flashed != %scanned))
               {
                  playSound(%player3,"explo3.wav",IDPRF_2D);
                  fadeEvent(%player3, in, 7, 3, 3, 3);
                  setVehicleSpecialIdentity(%flashed, true, "Yellow");
                  schedule("setVehicleSpecialIdentity(" @ %flashed @ ", false);", 7);
               }
            }
         }
      }
      else if(%player.currentitem=="EMP")
      {
         %player.hasitem = false;
         %player.currentitem = "";
         %x = getposition(%scanner,x);
         %y = getposition(%scanner,y);
         %z = getposition(%scanner,z)+3;
         %wave = copyObject($itemWave);
         addToSet(%player.group,%wave);
         schedule("setPosition("@%wave@","@%x@","@%y@","@%z@");",0.5);
         schedule("playAnimSequence("@%wave@",0,true);",0.5);
         schedule("deleteObject("@%wave@");",2.167);
         %count = playermanager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player3 = playermanager::getplayernum(%i);
            %victim = playermanager::playernumtovehicleId(%player3);
            %distance = getdistance(%scanner,%victim);
            if((%distance<=250)&&(%victim!=%scanner)&&(%victim!=0))
            {
               schedule("empFix("@%player3@");",0.9);
               schedule("empFix("@%player3@");",0.95);
               schedule("empFix("@%player3@");",0.99);
               schedule("say("@%player3@","@%player3@",\"<f4>You were hit by an EMP shockwave! All vehicle operating systems have been temporarily offlined.\");",0.75);
               schedule("violate("@%victim@");",1);
               schedule("reloadObject("@%victim@",5000);",1.25);
               schedule("playSound("@%player3@", \"plasma3.wav\", IDPRF_2D);",1);
               schedule("playSound("@%player3@", \"sfx_prob.wav\", IDPRF_2D);",1);
               schedule("playSound("@%player3@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
            }
         }
         for(%i=8000;%i<10000;%i++)
         {
            %name = getObjectname(%i);
            if((%name=="veh")&&(getDistance(%scanner,%i)<=250))
            {
               schedule("violate("@%i@");",1);
               schedule("order("@%i@",shutdown,true);",1);
               schedule("order("@%i@",shutdown,false);",7);
            }
            else if((strAlign(3,l,%name)=="tur")&&(%i!=$turHATC)&&(%i!=$turEMP)&&(%i!=$turHLAS)&&(%i!=$turHBLAS)&&(%i!=$turHBC)&&(%i!=$turBLINK)&&(%i!=$turELF)&&(%i!=$turMFAC)&&(%i!=$turNIKE)&&(%i!=$turPBW)&&(getDistance(%scanner,%i)<=250))
            {
               schedule("order("@%i@",shutdown,true);",1);
               schedule("order("@%i@",shutdown,false);",11);
            }
         }         
         say(%player,%player,"<f4>Emitting EMP Shockwave...");
         schedule("playSound("@%player@", \"plasma3.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player@", \"sfx_prob.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
      }
   }
}

function empFix(%player)
{
   %player.justlaid = true;
}

function vehicles::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleVeh(%player);
}

function toggleVeh(%player)
{
   if(%player.veh=="Target")
   {
      %player.veh = "Seek";
      say(%player,%player,"<f1>Current Selection: Jehrico (10 scarps)");
   }   
   else if(%player.veh=="Seek")
   {
      %player.veh = "Talo";
      say(%player,%player,"<f1>Current Selection: Razorback (11 scarps)");
   }
   else if(%player.veh=="Talo")
   {
      %player.veh = "Goad";
      say(%player,%player,"<f1>Current Selection: Altas (13 scarps)");
   }
   else if(%player.veh=="Goad")
   {
      %player.veh = "Bolo";
      say(%player,%player,"<f1>Current Selection: Ko'ah (16 scarps)");
   }
   else if(%player.veh=="Bolo")
   {
      %player.veh = "Aven";
      say(%player,%player,"<f1>Current Selection: Tycho (20 scarps)");
   }
   else if(%player.veh=="Aven")
   {
      %player.veh = "Mino";
      say(%player,%player,"<f1>Current Selection: Xenogears (25 scarps)");
   }
   else if(%player.veh=="Mino")
   {
      %player.veh = "Eman";
      say(%player,%player,"<f1>Current Selection: Icey (31 scarps)");
   }
   else if(%player.veh=="Eman")
   {
      %player.veh = "Myrm";
      say(%player,%player,"<f1>Current Selection: Delithita (38 scarps)");
   }
   else if(%player.veh=="Myrm")
   {
      %player.veh = "Target";
      say(%player,%player,"<f1>Current Selection: Maria (46 scarps)");
   }
}

function turrets::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleTurret(%player);
}

function toggleTurret(%player)
{
   if(%player.turret=="PS")
   {
      %player.turret = "EH";
      say(%player,%player,"<f1>Current Selection: EMP-HATC Turret (10 scarps)");
   }
   else if(%player.turret=="EH")
   {
      %player.turret = "S";
      say(%player,%player,"<f1>Current Selection: 2-Shrike Turret (15 scarps)");
   }
   else if(%player.turret=="S")
   {
      %player.turret = "P";
      say(%player,%player,"<f1>Current Selection: 2-PBW Turret (20 scarps)");
   }
   else if(%player.turret=="P")
   {
      %player.turret = "A";
      say(%player,%player,"<f1>Current Selection: Artillery Turret (30 scarps)");
   }
   else if(%player.turret=="A")
   {
      %player.turret = "PS";
      say(%player,%player,"<f1>Current Selection: 4-PBW 4-Shrike Turret (40 scarps)");
   }
}

function items::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleItem(%player);
}

function toggleItem(%player)
{
   if(%player.item=="Attack")
   {
      %player.item = "Field";
      say(%player,%player,"<f1>Current Selection: Stone Barrier (2 scarps)");
   }
   else if(%player.item=="Field")
   {
      %player.item = "Reload";
      say(%player,%player,"<f1>Current Selection: Instant Reload (5 scarps)");
   }
   else if(%player.item=="Reload")
   {
      %player.item = "Stun";
      say(%player,%player,"<f1>Current Selection: Stun Grenade (7 scarps)");
   }
   else if(%player.item=="Stun")
   {
      %player.item = "Prox";
      say(%player,%player,"<f1>Current Selection: Proximity Mine (3 scarps)");
   }
   else if(%player.item=="Prox")
   {
      %player.item = "Stasis";
      say(%player,%player,"<f1>Current Selection: Stasis Field (10 scarps)");
   }   
   else if(%player.item=="Stasis")
   {
      %player.item = "Ion";
      say(%player,%player,"<f1>Current Selection: Ion Cannon (12 scarps)");
   }
   else if(%player.item=="Ion")
   {
      %player.item = "EMP";
      say(%player,%player,"<f1>Current Selection: EMP Shockwave Generator (13 scarps)");
   }
   else if(%player.item=="EMP")
   {
      %player.item = "Repair";
      say(%player,%player,"<f1>Current Selection: Instant Repair/Reload (13 scarps)");
   }
   else if(%player.item=="Repair")
   {
      %player.item = "Ammo";
      say(%player,%player,"<f1>Current Selection: Reload Pad (15 scarps)");
   }   
   else if(%player.item=="Ammo")
   {
      %player.item = "Heal";
      say(%player,%player,"<f1>Current Selection: Repair Pad (18 scarps)");
   }
   else if(%player.item=="Heal")
   {
      %player.item = "Zen";
      say(%player,%player,"<f1>Current Selection: Repair/Reload Pad (20 scarps)");
   }
   else if(%player.item=="Zen")
   {
      %player.item = "Stealth";
      say(%player,%player,"<f1>Current Selection: Stealth Mode (20 scarps)");
   }
   else if(%player.item=="Stealth")
   {
      %player.item = "KSAT";
      say(%player,%player,"<f1>Current Selection: Siren Strike (50 scarps)");
   }
   else if(%player.item=="KSAT")
   {
      %player.item = "Sell";
      say(%player,%player,"<f1>Current Selection: Sell your current item for half price.");
   }
   else if(%player.item=="Sell")
   {
      %player.item = "Follow";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard you. (Free)");
   }
   else if(%player.item=="Follow")
   {
      %player.item = "Guard";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard your nav marker. (Free)");
   }
   else if(%player.item=="Guard")
   {
      %player.item = "Attack";
      say(%player,%player,"<f1>Resurrect the Ghosts (100 scarps)");
   }
}

function buyveh::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyVeh(%player, "Scan");
}

function hasMoney(%cost,%player)
{
   if(%player.scarps>=%cost)
   {
      %player.scarps -= %cost;
      return true;
   }
   else
   {
      say(%player,%player, "<f5>You only have "@%player.scarps@" scarps! That item requires "@%cost@" scarps. Earn more scarps by making kills.","alarm2.wav");
      return false;
   }
}

function buyVeh(%player, %method)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   %veh = "";
   %target = getTargetId(%vehicleId);
   if(%player.veh=="Seek")
   {
     if(%player.seek == true){
      say(%player,%player,"Sorry, you have already summoned Jehrico this game.");
      return; }
      if(hasMoney(10,%player)==true)
      {
         %veh = loadObject("ghost", "jehr.gse");
         setpilotid(%veh, 51);
         %veh.txt1 = "Skills: Luck.";
         %player.seek = true;
      }
   }
   else if(%player.veh=="Talo")
   {
     if(%player.talo == true){
      say(%player,%player,"Sorry, you have already summoned Razorback this game.");
      return; }
      if(hasMoney(11,%player)==true)
      {
         %veh = loadObject("ghost", "raza.gse");
         setpilotid(%veh, 52);
         %veh.txt1 = "Skills: Critical Targeting.";
         %player.talo = true;
      }    
   }
   else if(%player.veh=="Goad")
   {
     if(%player.goad == true){
      say(%player,%player,"Sorry, you have already summoned Altas this game.");
      return; }
      if(hasMoney(13,%player)==true)
      {
         %veh = loadObject("ghost", "alta.gse");
         setpilotid(%veh, 53);
         %veh.txt1 = "Skills: Ghosting.";
         %player.goad = true;
      }
   }
   else if(%player.veh=="Bolo")
   {
     if(%player.bolo == true){
      say(%player,%player,"Sorry, you have already summoned Ko'ah this game.");
      return; }
      if(hasMoney(16,%player)==true)
      {
         %veh = loadObject("ghost", "koah.gse");
         setpilotid(%veh, 54);
         %veh.txt1 = "Skills: Ghosting, Luck.";
         %player.bolo = true;
      }   
   }
   else if(%player.veh=="Aven")
   {
     if(%player.aven == true){
      say(%player,%player,"Sorry, you have already summoned Tycho this game.");
      return; }
      if(hasMoney(20,%player)==true)
      {
         %veh = loadObject("ghost", "tych.gse");
         setpilotid(%veh, 55);
         %veh.txt1 = "Skills: Critical Targeting, Luck.";
         %player.aven = true;
      }   
   }
   else if(%player.veh=="Mino")
   {
     if(%player.mino == true){
      say(%player,%player,"Sorry, you have already summoned Xenogears this game.");
      return; }
      if(hasMoney(25,%player)==true)
      {
         %veh = loadObject("ghost", "xeno.gse");
         setpilotid(%veh, 56);
         %veh.txt1 = "Skills: Feedback.";
         %player.mino = true;
      }   
   }
   else if(%player.veh=="Eman")
   {
     if(%player.eman == true){
      say(%player,%player,"Sorry, you have already summoned Icey this game.");
      return; }
      if(hasMoney(31,%player)==true)
      {
         %veh = loadObject("ghost", "icey.gse");
         setpilotid(%veh, 57);
         %veh.txt1 = "Skills: Feedback, Luck.";
         %player.eman = true;
      }   
   }
   else if(%player.veh=="Myrm")
   {
     if(%player.myrm == true){
      say(%player,%player,"Sorry, you have already summoned Delithita this game.");
      return; }
      if(hasMoney(38,%player)==true)
      {
         %veh = loadObject("ghost", "deli.gse");
         setpilotid(%veh, 58);
         %veh.txt1 = "Skills: Feedback, Critical Targeting.";
         %player.myrm = true;
      }   
   }
   else if(%player.veh=="Target")
   {
     if(%player.targ == true){
      say(%player,%player,"Sorry, you have already summoned Maria this game.");
      return; }
      if(hasMoney(46,%player)==true)
      {
         %veh = loadObject("ghost", "merc.gse");
         setpilotid(%veh, 59);
         %veh.txt1 = "Skills: Feedback, Critical Targeting, Ghosting, Luck.";
         %player.targ = true;
      }   
   }
   if(%veh!="")
   {
      addToSet("Missiongroup\\group"@%player, %veh);      
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%veh, getTeam(%vehicleId));
      order(%veh, guard, %vehicleId);
      order(%veh, speed, high);      
      %x1 = getposition(%vehicleId,x)-200;
      %x2 = getposition(%vehicleId,x)+200;
      %y1 = getposition(%vehicleId,y)-200;
      %y2 = getposition(%vehicleId,y)+200;
      randomTransport(%veh,%x1,%y1,%x2,%y2);
      %player.aicount++;
      say(%player,%player,"<f4>Thank you for summoning "@getVehicleHudName(%veh)@"'s "@getVehiclename(%veh)@"! Scan to give orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.scarps@" scarps remaining.");
      say(%player,%player,getVehicleHudName(%veh)@" has "@%veh.txt1@" ");
      %veh.owner = %player;
      %veh.order = "follow";
      echo(%player@" "@getname(%player)@" purchased vehicle: "@%player.veh);
   }
}

function glitchdie(%v, %w){
 $whichnav++;
 if($whichnav == 7){ $whichnav = 1; }
 warp( "Missiongroup\\cybpath\\navigationmarker"@$whichnav, %w); 
 %which = randomint(1, 9);
 %veh = loadobject( "glitch", "cybrid"@%which@".gse" );
 addtoset("MissionGroup/cybrids", %veh);
 setposition(%veh, randomint(-3000, -2000), randomint(2000, 4000), 500);
 setpilotid(%veh, 29);
 %veh.isGlitch = true;
 order("missiongroup/cybrids", guard, "MissionGroup/cybpath"); }

function merc::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 feedback(%v, %w);
 luck(%v, %w);
 ghosting(%v, %w);
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 10 );
 %rand = randomInt(1,10);
 if(%rand == 2){ say(0,0,"Maria: Now it's my turn.", "F6_DWish_nowitsmyturn.WAV"); }
 else{
  %player = playermanager::vehicleIdtoPlayerNum(%w);
  if(%player != 0){ say(0,%player,"Maria: Prepare to die."); } }
 criticalTargeting(%v, %w); }

function deli::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 feedback(%v, %w);
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 20 );
 %rand = randomInt(1,5);
 if(%rand == 2){ say(0,0,"Delithita: Oh yeah THAT'S IT!", "F4_Tiger_ohyeah.WAV"); }
 else{
  %player = playermanager::vehicleIdtoPlayerNum(%w);
  if(%player != 0){ say(0,%player,"Delithita: Prepare to die."); } }
 criticalTargeting(%v, %w); }

function icey::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 feedback(%v, %w);
 luck(%v, %w); }

function xeno::vehicle::onattacked(%v, %w){
 if(getteam(%v) == getteam(%w)){ return; }
 feedback(%v, %w); }

function tych::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 luck(%v, %w);
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 30 );
 %rand = randomInt(1,3);
 if(%rand == 2){ say(0,0,"Tycho: You're insane.  And dead.", "M1_DM_yourinsane.WAV"); }
 else{
  %player = playermanager::vehicleIdtoPlayerNum(%w);
  if(%player != 0){ say(0,%player,"Tycho: Prepare to die."); } }
 criticalTargeting(%v, %w); }

function koah::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 luck(%v, %w);
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 4 );
 ghosting(%v, %w); }

function alta::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 5 );
 ghosting(%v, %w); }

function raza::vehicle::onattacked(%v, %w){ 
 if(getteam(%v) == getteam(%w)){ return; }
 if(%v.a == true){ return; }
 %v.a = true;
 schedule( "reseta("@%v@");", 60 );
 %rand = randomInt(1,2);
 if(%rand == 2){ say(0,0,"Razorback: You're going down!", "M1_DM_yourgoing.WAV"); }
 else{
  %player = playermanager::vehicleIdtoPlayerNum(%w);
  if(%player != 0){ say(0,%player,"Razorback: Prepare to die."); } }
 criticalTargeting(%v, %w); }

function jehr::vehicle::onattacked(%v, %w){
 if(getteam(%v) == getteam(%w)){ return; }
 luck(%v, %w); }

function reseta(%v){ %v.a = false; }

function feedback(%v, %w){
 damageObject(%w, randomint(10, 100));
 healobject(%v, randomint(10, 200)); }

function luck(%v, %w){ healobject(%v, randomint(10, 200)); }

function criticalTargeting(%v, %w){
 %player = %v.owner;
 order(%player.group,cloak,true);
 order(%player.group,attack,%w);
 order(%player.turgroup, attack, 0);
 order(%player.turgroup, clear);
 say(%player,%player,"<f4>"@getVehicleHudname(%v)@" has ordered your team to attack "@getvehiclehudname(%w)@" ("@getvehiclename(%w)@")."); }

function ghosting(%v, %w){ 
 setvehicleradarvisible(%v, false);
 order(%w, attack, 0);
 order(%w, clear); }

function buyturret::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyTurret(%player);
}

function buyTurret(%player)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   %tur = "";
   %nav = getVehicleNavMarkerId(%vehicleId);
   if($server::teamplay==true)
   {
      if(getPosition(%nav)=="0.000000 0.000000 0.000000")
      {
         %thing = %vehicleId;
      }
      else
      {
         %thing = %nav;
      }
      if((getTeam(%player)!="Yellow Team")&&(getDistance(%thing, $navYellow)<=750))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 750 meters of an enemy base!");
         return;
      }
      if((getTeam(%player)!="Blue Team")&&(getDistance(%thing, $navBlue)<=750))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 750 meters of an enemy base!");
         return;
      }
      if((getTeam(%player)!="Red Team")&&(getDistance(%thing, $navRed)<=750))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 750 meters of an enemy base!");
         return;
      }
      }
   }
   if(%player.turret=="EH")
   {
      if(hasMoney(10,%player)==true)
      {
         %tur = copyObject($turHATC);
         setStaticShapeShortName(%tur,getName(%player)@"'s EMP-HATC Turret");
      }
   }
   else if(%player.turret=="S")
   {
      if(hasMoney(15,%player)==true)
      {
         %tur = copyObject($turHLAS);
         setStaticShapeShortName(%tur,getName(%player)@"'s Shrike Turret");
      }
   }
   else if(%player.turret=="P")
   {
      if(hasMoney(20,%player)==true)
      {
         %tur = copyObject($turHBC);
         setStaticShapeShortName(%tur,getName(%player)@"'s PBW Turret");
      }
   }
   else if(%player.turret=="PS")
   {
      if(hasMoney(40,%player)==true)
      {
         %tur = copyObject($turELF);
         setStaticShapeShortName(%tur,getName(%player)@"'s PBW-Shrike Turret");
      }
   }
   else if(%player.turret=="A")
   {
      if(hasMoney(30,%player)==true)
      {
         %tur = copyObject($turNIKE);
         setStaticShapeShortName(%tur,getName(%player)@"'s Artillery Turret");
      }
   }
   if(%tur!="")
   {
      addToSet(%player.turgroup, %tur);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%tur, getTeam(%vehicleId));
      %tur.owner = %player;
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         %x1 = getposition(%vehicleId,x)-200;
         %x2 = getposition(%vehicleId,x)+200;
         %y1 = getposition(%vehicleId,y)-200;
         %y2 = getposition(%vehicleId,y)+200;
         %x = randomInt(%x1, %x2);
         %y = randomInt(%y1, %y2);
         %z = getTerrainHeight(%x, %y);
         setposition(%tur,%x,%y,%z);
         say(%player,%player,"<f4>Thank you for purchasing a turret! Because you have not placed a nav marker, your turret has been built nearby. You can order your turrets to attack your target by spotting it with LTADs. You have "@%player.scarps@" scarps remaining.");
      }
      else
      {
         %nav = getVehicleNavMarkerId(%vehicleId);
         %x = getposition(%nav,x);
         %y = getposition(%nav,y);
         %z = getTerrainHeight(%x,%y);
         setPosition(%tur,%x,%y,%z);
         say(%player,%player,"<f4>Thank you for purchasing a turret! It has been built at your nav marker. You can order your turrets to attack your target by spotting it with LTADs. You have "@%player.scarps@" scarps remaining.");
      }      
      echo(%player@" "@getname(%player)@" purchased turret: "@%player.turret);
   }
}

function buyitem::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyItem(%player);
}

function buyItem(%player)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   if(%player.item=="Reload")
   {
      if(hasMoney(5,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         reloadObject(%vehicleId,50000);
         say(%player,%player, "<f4>Your ammunition has been replenished. You have "@%player.scarps@" scarps remaining.","reload_complete.wav");
      }
   }
   else if(%player.item=="Field")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(2,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasItem = true;
            %player.currentItem = "Field";
            say(%player,%player, "<f4>Thank you for purchasing an stone barrier. Shut down to deploy it. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }   
   else if(%player.item=="Stun")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(7,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasItem = true;
            %player.currentItem = "Stun";
            say(%player,%player, "<f4>Thank you for purchasing a stun grenade. Scan an enemy vehicle to temporarily blind them. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Prox")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(3,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "Prox";
            say(%player,%player, "<f4>Thank you for purchasing a proximity mine. Shut down to deploy it. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Stasis")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(10,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "Stasis";
            say(%player,%player, "<f4>Thank you for purchasing a stasis field generator. Scan an enemy vehicle to trap them inside a stasis field for 60 seconds. Shut down to create a protective stasis field around your vehicle. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Repair")
   {
      if(hasMoney(13,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         reloadObject(%vehicleId,50000);
         say(%player,%player, "<f4>Your vehicle has been fully repaired and reloaded. You have "@%player.scarps@" scarps remaining.","repairs_complete.wav");
      }
   }
   else if(%player.item=="Ammo")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(15,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemAmmo);
            %pad = newObject("Item",StaticInterior,"hammot.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a reload pad. It has been built at your nav marker. You have "@%player.scarps@" scarps remaining.");
         }
      }    
   }
   else if(%player.item=="Ion")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(12,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "Ion";
            say(%player,%player, "<f4>Thank you for purchasing an ion cannon. Scan an enemy vehicle to fire it. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="EMP")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(13,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "EMP";
            say(%player,%player, "<f4>Thank you for purchasing an EMP shockwave generator. Scan an enemy vehicle to use. It will temporarily disable all electronic systems on any vehicle or turret within a 250 meter radius. You have "@%player.scarps@" scarps remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Heal")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(18,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemHeal);
            %pad = newObject("Item",StaticInterior,"hhealt.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a repair pad. It has been built at your nav marker. You have "@%player.scarps@" scarps remaining.");
         }
      }   
   }
   else if(%player.item=="Zen")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(20,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemZen);
            %pad = newObject("Item",StaticInterior,"hhealt.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a repair/reload pad. It has been built at your nav marker. You have "@%player.scarps@" scarps remaining.");
         }
      }   
   }
   else if(%player.item=="Stealth")
   {
      if(hasMoney(20,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         setVehicleRadarVisible(%vehicleId,false);
         say(%player,%player, "<f4>Your vehicle is now radar invisible until it is destroyed. You have "@%player.scarps@" scarps remaining.","bc_mfd.wav");
      }
   }
   else if(%player.item=="KSAT")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify the coordinates for the K-SAT attack.");
      }
      else
      {
         if($lastKSAT=="")
         {
            if(hasMoney(50,%player)==true)
            {
              %tur = copyObject($turSiren);
              setStaticShapeShortName(%tur,getName(%player)@"'s Siren's Missiles");
              addToSet(%player.turgroup, %tur);
              setHercOwner(%player.group, %player.group);
              setHercOwner(%player.group, %player.turgroup);
              setHercOwner(%player.group, %vehicleId);
              setTurretOwner(%player.turgroup, %player.turgroup);
              setTurretOwner(%player.turgroup, %player.group);
              setTurretOwner(%player.turgroup, %vehicleId);
              setTeam(%tur, getTeam(%vehicleId));
              %tur.owner = %player;
               echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
               $lastKSAT=%player;
               %wave = copyObject($itemWave);
               %siren = copyObject($itemSiren);
               addToset(%player.group,%wave);
               %nav = getVehicleNavMarkerId(%vehicleId);
               %x = getposition(%nav,x);
               %y = getposition(%nav,y);
               %z = getTerrainHeight(%x,%y);               
               say(0,83,"<f5>WARNING: Siren Bomber detected.","warn_missl_lock.wav");
               setposition(%siren, %x, %y+200, %z + 301);
               %sec = 0;
               turretFollowSiren(%tur, %siren, %sec);
               setposition($itemMarker, %x, %y-200, %z + 301);
               order(%siren, speed, high);
               order(%siren, guard, $itemMarker);
               schedule("flushChannel(83);",0.65);
               setHudTimer(10,-1,"Siren incoming",2,%player);
               playSound(0,"sfx_quake.wav",IDPRF_2D);
               schedule("pod("@%siren@","@%x@","@%y@","@%z@");", 8);              
               schedule("playSound(0,\"sfx_shrk.wav\",IDPRF_2D);",8);
               schedule("playSound(0,\"sfx_min.wav\",IDPRF_2D);",8);
               schedule("playSound(0,\"sfx_reactor_xplo.wav\",IDPRF_2D);",10);
               schedule("setPosition("@%wave@","@%x@","@%y@","@%z+3@");",9.5);
               schedule("damageArea("@%wave@",0,0,0,200,999999999);",10.5);
               schedule("damageArea("@%wave@",75,0,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",-75,0,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",0,75,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",0,-75,0,100,999999999);",10.5);
               schedule("playAnimSequence("@%wave@",0,true);",9.5);
               schedule("deleteObject("@%wave@");",11.667);
               schedule("deleteObject("@%siren@");",20);
               schedule("$lastKSAT=\"\";",15);
            }
         }
         else
         {
            say(%player,%player,"<f4>Siren is otherwise engaged. Try again later.");
         }
      }
   }
   else if(%player.item=="Sell")
   {      
      if(%player.hasItem==false)
      {
         say(%player,%player,"<f5>You do not have an item to sell.");
      }
      else
      {
         sellItem(%player);
         echo(%player@" "@getname(%player)@" sold item");
      }
   }
   else if(%player.item=="Follow")
   {
      order(%player.group,cloak,true);
      order(%player.group,guard,%vehicleId);
      say(%player,%player,"<f4>All of your AI vehicles have been ordered to guard you.");
   }
   else if(%player.item=="Guard")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify a location for your AI vehicles to guard.");
      }
      else
      {
         %nav = getVehicleNavMarkerId(%vehicleId);
         %x = getposition(%nav,x);
         %y = getposition(%nav,y);
         %z = getTerrainHeight(%x,%y);
         order(%player.group,cloak,true);
         order(%player.group,guard,%x,%y,%z);
         say(%player,%player,"<f4>All of your AI vehicles have been ordered to guard your nav marker.");
      }
   }
   else if(%player.item=="Attack")
   {
            if(hasMoney(100,%player)==true)
            {
          say(0,0,"The Ghosts haunt...", "sfx_quake.wav");
          %player.seek = "";
          %player.talo = "";
          %player.aven = "";
          %player.myrm = "";
          %player.targ = "";
          %player.goad = "";
          %player.bolo = "";
          %player.eman = "";
     }
   }
}

function pod(%siren,%x, %y, %z){
 %x2 = getposition(%siren, x);
 %y2 = getposition(%siren, y);
 %z2 = getposition(%siren, z);
 dropPod(%x2,%y2,%z2,%x,%y,%z);
 setPosition($itemmarker, 0, -8000, 7000);
 order(%siren, guard, $itemmarker); }

function turretFollowSiren(%tur, %siren, %sec){
 warp(%tur, %siren);
 %sec = %sec + 0.2;
 if(%sec < 18){ schedule("turretfollowsiren("@%tur@", "@%siren@", "@%sec@");", 0.2 ); }
 else{ deleteObject(%tur); } }

function vehicle::onarrived(%vehicleId,%where)
{
   order(%vehicleId,cloak,true);
}

function useItem(%vehicleid)
{
   %player = playermanager::vehicleidtoplayernum(%vehicleid);
   %player.hasitem = false;
   if(%player.currentitem=="Field")
   {
      %field = copyObject($itemField);
      addToSet(%player.group,%field);
      setTeam(%field,getTeam(%vehicleId));
      %x = (getposition(%vehicleId,x) + randomInt(-20, 20));
      %y = (getposition(%vehicleId,y) + randomInt(-20, 20));
      %z = (getterrainheight(%x, %y) + 1);
      %rotRad = getPosition(%vehicleId,rot);
      %rotDeg = RadToDeg(%rotRad)+90;
      %rot = round(adjustAngle(%rotDeg));
      setPosition(%field,%x,%y,%z,%rot);
      say(%player,%player,"<f4>Stone Barrier Deployed","sfx_meteor.wav");
      %player.currentitem = "";
   }
   else if(%player.currentitem=="Prox")
   {
      %trig = copyObject($itemProx);
      %trig.mine = copyObject($itemMine);
      addToSet(%player.group,%trig);
      addToSet(%player.group,%trig.mine);
      %trig.owner = %player;
      %trig.exp = newObject("Item", staticShape, "fx_exp_podT.dts");
      addtoset(%player.group,%trig.exp);
      setPosition(%trig.exp,10000,10000,-10000);
      %x = getposition(%vehicleId,x);
      %y = getposition(%vehicleId,y);
      %z = getTerrainHeight(%x,%y)+0.2;
      setPosition(%trig,%x,%y,%z-0.2);
      setPosition(%trig.mine,%x,%y,%z);
      %trig.armed = false;
      schedule("armMine("@%trig@");",10);
      setHudTimer(0,-1,"",1,%player);
      setHudTimer(10,-1,"Mine Arms In:",1,%player);
      %player.currentitem = "";
   }
   else if(%player.currentitem=="Stasis")
   {
      %field1 = copyObject($itemStasis);
      %field2 = copyObject($itemStasis);
      %field3 = copyObject($itemStasis);
      %field4 = copyObject($itemStasis);
      addToSet(%player.group,%field1);
      addToSet(%player.group,%field2);
      addToSet(%player.group,%field3);
      addToSet(%player.group,%field4);    
      %x = getposition(%vehicleId,x);
      %y = getposition(%vehicleId,y);
      %z1 = getTerrainHeight(%x,%y+30)+24;
      %z2 = getTerrainHeight(%x+30,%y)+24;
      %z3 = getTerrainHeight(%x,%y-30)+24;
      %z4 = getTerrainHeight(%x-30,%y)+24;
      setPosition(%field1,%x,%y+30,%z1,90,180);
      setPosition(%field2,%x+30,%y,%z2,0,180);
      setPosition(%field3,%x,%y-30,%z3,90,180);
      setPosition(%field4,%x-30,%y,%z4,0,180);
      say(%player,%player,"<f4>Protective stasis field deployed.","sfx_electrical_bzzt.wav");
      setHudTimer(0,-1,"",3,%player);
      setHudTimer(60,-1,"Stasis Field:",3,%player);
      schedule("deleteObject("@%field1@");",60);
      schedule("deleteObject("@%field2@");",60);
      schedule("deleteObject("@%field3@");",60);
      schedule("deleteObject("@%field4@");",60);
      %player.currentitem = "";
   }
}

function sellItem(%player)
{
   if(%player.currentitem=="Stun")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=3;
      say(%player,%player,"<f4>You have sold your stun grenade for 3 scarps. You now have "@%player.scarps@" scarps.");
   }
   else if(%player.currentitem=="Field")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=1;
      say(%player,%player,"<f4>You have sold your stone barrier for 1 scarp. You now have "@%player.scarps@" scarps.");
   }
   else if(%player.currentitem=="Prox")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=1;
      say(%player,%player,"<f4>You have sold your proximity mine for 1 scarp. You now have "@%player.scarps@" scarps.");
   }
   else if(%player.currentitem=="Stasis")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=5;
      say(%player,%player,"<f4>You have sold your stasis field for 5 scarps. You now have "@%player.scarps@" scarps.");
   }
   else if(%player.currentitem=="Ion")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=6;
      say(%player,%player,"<f4>You have sold your ion cannon for 6 scarps. You now have "@%player.scarps@" scarps.");
   }
   else if(%player.currentitem=="EMP")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.scarps+=7;
      say(%player,%player,"<f4>You have sold your EMP shockwave generator for 7 scarps. You now have "@%player.scarps@" scarps.");
   }
}

function armMine(%trig)
{
   %trig.armed = true;
   say(%trig.owner,%trig.owner, "<f4>Proximity Mine Armed.","sfx_cmd.wav");
}

function trigger::onenter(%trigger,%vehicleid)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if((%name=="PROX")&&(%trigger.armed==true))
   {
      if(($antispawnkillProx==true)&&($server::teamplay==true)&&(%player.invincible==true))
      {
         playSound(%player,"mine_field_det.wav",IDPRF_2D);
      }
   }
   else if((%name=="PROX")&&(%trigger.armed==false)&&(%trigger.owner!=%player)&&(%player!=0))
   {
      playSound(%player,"mine_field_det.wav",IDPRF_2D);
      echo(getname(%player)@" was warned of an arming mine.");
   }
   else if(%name=="Ammo")
   {
      if(%player != 0)
      {
   	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_AMMOPAD, true, true);
         %player.InPad = true;
      }
   }
   else if(%name=="HealTrig")
   {
      if(%player != 0)
      {
     	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_HEALPAD, true, true);
         %player.InPad = true; 
      }
   }
   else if(%name=="Zen")
   {
      if(%player != 0)
      {
   	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_ALLPAD, true, true);
         %player.InPad = true; 
      }
   }
}

function trigger::onContact(%trigger,%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if((%name=="PROX")&&(%trigger.armed==true))
   {
      if(($antispawnkillProx==true)&&($server::teamplay==true)&&(%player.invincible==true))
      {
         echo(getname(%player)@" hit mine but was invincible");
      }
      else
      {
         %vehicleId.hitamine = true;
         %x = getposition(%trigger,x);
         %y = getposition(%trigger,y);
         %z = getposition(%trigger,z); 
         setPosition(%trigger.exp,%x,%y,%z);
         playAnimSequence(%trigger.exp,0,true);
         if(%player!=%trigger.owner)
         {
            %owner = %trigger.owner;
            if(($server::teamplay==true)&&(getTeam(%owner)==getTeam(%vehicleId)))
            {
               echo("PROX TEAMKILL - No points awarded");
            } 
            else if(%vehicleId.owner==%owner)
            {
               echo("PROX AI TEAMKILL - No points awarded");
            }   
            else
            {
               %owner.extraKills++;
               %owner.scarps+=1;
            }
            say(0,5,getHudName(%vehicleId)@" stepped on one of "@getName(%trigger.owner)@"'s mines!");
         }
         else
         {
            say(0,5,getHudName(%vehicleId)@" accidentally stepped on one of his own mines!");
         }
         resetLastHitBy(%vehicleId);
         healObject(%vehicleId,-5000);
         playSound(0,"sfx_fog.wav",IDPRF_2D);
         schedule("proxFix("@%trigger@");",0.5);
         setposition(%trigger,0,0,-1000);
         setposition(%trigger.mine,0,0,-1000);
         schedule("deleteObject("@%trigger@");",1.067);
         schedule("deleteObject("@%trigger.mine@");",1.067);
         schedule("deleteObject("@%trigger.exp@");",1.067);
      }
   }
   else if(%name=="Ammo")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 0, 40, 40, true); 
      }
      else
      {
         reloadObject(%vehicleid,50000);
      }
   }
   else if(%name=="HealTrig")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 1000, 0, 0, true); 
      }
      else
      {
         healObject(%vehicleid,400);
      }
   }
   else if(%name=="Zen")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 1000, 40, 70, true); 
      }
      else
      {
         healObject(%vehicleid,400);
         reloadObject(%vehicleid,50000);
      }
   }
}

function proxFix(%trigger)
{
   %trigger.owner = "";
}

function trigger::onLeave(%trigger,%vehicleid)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if((%name=="Ammo")||(%name=="HealTrig")||(%name=="Zen"))
   {
      %player.InPad = false;
   }
}

function onMissionEnd()
{
   flushConsoleScheduler();
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getPlayerNum(%i);
      deleteObject(%player.group);
      %player.group = "";
   }
}

function deployItem::trigger::onContact(%trigger, %vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   if(%player!=0)
   {
      if(isshutdown(%vehicleId) == false)
      {
         %player.justlaid = false;
      }
      if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.hasItem == true)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
         useItem(%vehicleId);
      }  
      else if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.hasItem == false)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
         say(%player,%player, "<f5>You do not have a deployable item.");
      }
   }
}

function cleanUpDeadTurrets()
{
   for(%i=2049;%i<2100;%i++)
   {
      if((getConnection(%i)=="")&&(getObjectName(%i.group)!=False))
      {
         deleteObject(%i.group);
         %i.group = "";
      }
   }
   echo("NOTE: This is normal. Ignore the error messages.");
   %num=0;
   for(%i=8000; %i<10000; %i++)
   {
      if((strAlign(3,l,getObjectName(%i))=="tur")&&(isGroupDestroyed(%i)==true)&&(%i!=$turHATC)&&(%i!=$turEMP)&&(%i!=$turHLAS)&&(%i!=$turHBLAS)&&(%i!=$turHBC)&&(%i!=$turBLINK)&&(%i!=$turELF)&&(%i!=$turMFAC)&&(%i!=$turNIKE)&&(%i!=$turPBW))
      {
         %i.owner = "";
         deleteObject(%i);
         %num++;
      }
   }
   if(%num!=0)
   {
      echo("CLEANUP REPORT: Found "@%num@" loose turrets. Deleting the leftovers now.");
   }
   schedule("cleanUpDeadTurrets();",300);
}

function structure::ondestroyed(%destroyed,%destroyer)
{
   if(getObjectName(%destroyed)=="Field")
   {
      schedule("deleteObject("@%destroyed@");",1);
   }
}

function getScarps(%player)
{
   return %player.scarps;
}

function getAllKills(%player)
{
   return(getKills(%player) + %player.extraKills);
}

function getPlayerScore(%a)
{
   return((getAllKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints));
}

function getAllTeamKills(%a)
{
   return(getTeamKills(%a) + getExtraTeamKills(%a));
}

function getTeamScore(%a)
{
   return((getAllTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints));
}

function getExtraTeamKills(%a)
{
   %index0 = "Yellow Team";
   %index1 = "Blue Team";
   %index2 = "Red Team";
   %index3 = "Purple Team";
   %teamIndex = getTeamColorFromBits(%a);
   %color = %index[%teamindex];
   %teamExtraKills = 0;
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      if(getTeam(%player)==%color)
      {
         %teamExtraKills += %player.extrakills;
      }
   }
   return %teamExtraKills;
}

function getAIcount(%player)
{
   return %Player.aicount;
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
	   $ScoreBoard::PlayerColumnHeader2 = "Scarps";
	   $ScoreBoard::PlayerColumnHeader3 = "Score";
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
	   $ScoreBoard::PlayerColumnHeader6 = "AI Count";
	   $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
	   $ScoreBoard::PlayerColumnFunction2 = "getScarps";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
	   $ScoreBoard::PlayerColumnFunction6 = "getAIcount";
	   $ScoreBoard::PlayerColumnFunction7 = "getSquad";
   }
   else
   {
       // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader2 = "Scarps";
	   $ScoreBoard::PlayerColumnHeader3 = "Score";
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
	   $ScoreBoard::PlayerColumnHeader6 = "AI Count";

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getScarps";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
	   $ScoreBoard::PlayerColumnFunction6 = "getAIcount";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getAllTeamKills";
   $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

function RadToDeg(%radians)
{
   %degrees = (%radians * 180) / 3.14159;
   return %degrees;
}

function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}

function adjustAngle(%angle)
{
   if(%angle >= 360)
   {
      while(%angle >= 360)
      {
         %angle = (%angle - 360);
      }
   }
   else if(%angle < 0)
   {
      while(%angle < 0)
      {
         %angle = (%angle + 360);
      }
   }
   return %angle;
}


// Free Scarps Easter Egg Function (For overly generous hosts)
// TYPE: focusserver();freeScarps(50);focusclient();

function freeScarps(%amount)
{
   if(%amount=="")
   {
      %amount = 50;
   }
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      %player.scarps+=%amount;
   } 
}

//Set all player scarps to one amount
//Use as above
function setScarps(%amount)
{
   if(%amount=="")
   {
      %amount = 30;
   }
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      %player.scarps = %amount;
   } 
}

