// FILENAME:	C&D_Circular_Logic.cs
//
// AUTHOR:  	Gen. Raven [M.I.B.]
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "C&D Antipode";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = 3000;
$server::HudMapViewOffsetY = -8000;

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;  
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

$antiSpawnKill = true; //Anti-Spawnkill option for teamplay
                       //Players are invincible for 10 seconds after spawning

$antiSpawnKillProx = true; //Cant hit prox mines until 10 seconds after spawn.
                           //If true...the above MUST also be set to true                           

$initCredits = 30; //Amount of credits each player starts with
$lastKSAT = "";

if(($antiSpawnKillProx==true)&&($antispawnkill==false))
{
   $antiSpawnKill = true;
   echo("You have to have antispawnkill on for antispawnkillprox to work!");
}

Pilot Elite
{
   id = 28;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 500.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Ghost
{
   name = "Ghost Icey";
   id = 29;
   skill = 2.0;
   accuracy = 2.0;
   aggressiveness = 2.0;
   activateDist = 750.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot GhostD
{
   name = "Ghost Delithita";
   id = 34;
   skill = 2.0;
   accuracy = 2.0;
   aggressiveness = 2.0;
   activateDist = 750.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Glitch
{
   name = "Cybrid Defender";
   id = 30;
   skill = 2.0;
   accuracy = 1.0;
   aggressiveness = 2.0;
   activateDist = 750.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Altas
{
   name = "Ghost Altas";
   id = 31;
   skill = 2.0;
   accuracy = 1.5;
   aggressiveness = 0.7;
   activateDist = 750.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Razorback
{
   name = "Ghost Razorback";
   id = 32;
   skill = 2.0;
   accuracy = 0.5;
   aggressiveness = 2.0;
   activateDist = 350.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

Pilot Icemanyurt
{
   name = "Ghost Icemanyurt";
   id = 33;
   skill = 1.5;
   accuracy = 1.5;
   aggressiveness = 1.5;
   activateDist = 550.0;
   deactivateBuff = 100.0;
   targetFreq = 1.0;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
};

function innerplanetSounds(){
 meteorSounds();
 %weather1 = getObjectId("MissionGroup\\World\\sky");
 createAmbientSoundSource(%weather1, 0, 10, 12);
 addToAmbientSoundSource(%weather1, "sfx_quake.wav", IDPRF_2D); }

function onMissionStart()
{
   innerPlanetSounds();

   $turHATC = getObjectId("MissionGroup\\OrigTurrets\\tur0");
   $turEMP = getObjectId("MissionGroup\\OrigTurrets\\tur1");
   $turHLAS = getObjectId("MissionGroup\\OrigTurrets\\tur2");
   $turHBLAS = getObjectId("MissionGroup\\OrigTurrets\\tur3");
   $turHBC = getObjectId("MissionGroup\\OrigTurrets\\tur4");
   $turBLINK = getObjectId("MissionGroup\\OrigTurrets\\tur5");
   $turELF = getObjectId("MissionGroup\\OrigTurrets\\tur6");
   $turMFAC = getObjectId("MissionGroup\\OrigTurrets\\tur7");
   $turNIKE = getObjectId("MissionGroup\\OrigTurrets\\tur8");
   $turPBW = getObjectId("MissionGroup\\OrigTurrets\\tur9");
   $itemZen = getObjectId("MissionGroup\\ItemGroup\\Zen");
   $itemHeal = getObjectId("MissionGroup\\ItemGroup\\HealTrig");
   $itemAmmo = getObjectId("MissionGroup\\ItemGroup\\Ammo");
   $itemProx = getObjectId("MissionGroup\\ItemGroup\\Prox");
   $itemMine = getObjectId("MissionGroup\\ItemGroup\\mine");
   $itemField = getObjectId("MissionGroup\\ItemGroup\\Field");
   $itemWave = getObjectId("MissionGroup\\ItemGroup\\Wave");
   $itemStasis = getObjectId("MissionGroup\\ItemGroup\\Stasis");
   $itemKinetrig = getObjectId("MissionGroup\\ItemGroup\\kinetrig");
   $itemKinetron = getObjectId("MissionGroup\\ItemGroup\\kinetron");
   $itemSnaretur = getObjectId("MissionGroup\\ItemGroup\\snareturret");
   $itemSnare = getObjectId("MissionGroup\\ItemGroup\\Snare");
   $itemBuytur = getObjectId("MissionGroup\\ItemGroup\\buytur");
   $itemBuyitem = getObjectId("MissionGroup\\ItemGroup\\buyitem");
   $itemBuyveh = getObjectId("MissionGroup\\ItemGroup\\buyveh");
   $ksatBeam = getObjectId("MissionGroup\\ItemGroup\\ksatBeam");
   $navYellow = getObjectId("MissionGroup\\YellowBase\\navYellow");
   $navBlue = getObjectId("MissionGroup\\BlueBase\\navBlue");
   $navRed = getObjectId("MissionGroup\\RedBase\\navRed");
   $navPurple = getObjectId("MissionGroup\\PurpleBase\\navPurple");
   $nexus1 = getObjectId("MissionGroup\\Base\\1");
   $nexus2 = getObjectId("MissionGroup\\Base\\2");
   $nexus3 = getObjectId("MissionGroup\\Base\\3");
   $nexus4 = getObjectId("MissionGroup\\Base\\4");
   schedule("cleanUpDeadTurrets();",300);

   if(($server::TimeLimit != "")&&($server::TimeLimit > 5))
   {
      %time = ($server::timelimit - 5) * 60; 
      schedule("fiveMinuteWarning();", %time);
   }
 $nexus = 0;
 $nexusowner = 0;
 schedule("nexuscount();", 1);
}
echo("200");
function nexuscount(){
 $nexus++;
 if($nexus == 100){ resetnexus(); }
 schedule("nexuscount();", 1); }

function resetnexus(){
 $nexus = 0;
 say(0,20,"<F5>Nexus communications reset.", "sfx_cybrid_indust.wav");
 $nexusowner = 0;
 setteam($nexus1, *IDSTR_TEAM_NEUTRAL);
 setteam($nexus2, *IDSTR_TEAM_NEUTRAL);
 setteam($nexus3, *IDSTR_TEAM_NEUTRAL);
 setteam($nexus4, *IDSTR_TEAM_NEUTRAL);
 order($nexus1, guard, "Missiongroup\\base\\cnexus1");
 order($nexus2, guard, "Missiongroup\\base\\cnexus1");
 order($nexus3, guard, "Missiongroup\\base\\cnexus1");
 order($nexus4, guard, "Missiongroup\\base\\cnexus1"); }

function glitchchicken::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 if(%v.isglitch != false){ %v.isglitch = true; }
 setpilotid(%v, 30); }

function glitchdogpile::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 %v.isglitch = true;
 setpilotid(%v, 30); }

function glitchchicken::vehicle::ondestroyed(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 if(%v.isglitch == false){ return; }
 %w = loadobject("veh", "glitchchicken.gse");
 setposition(%w, randomint(-1200, -600), randomint(-1600, -1000), 1000);
 if(%v == $nexus1){ $nexus1 = %w; }
 else if(%v == $nexus2){ $nexus2 = %w; }
 schedule("deleteObject("@%v@");", 2);
 setpilotid(%w, 30); }

function glitchdogpile::vehicle::ondestroyed(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 %w = loadobject("veh", "glitchdogpile.gse");
 setposition(%w, randomint(-1200, -600), randomint(-1600, -1000), 1000);
 if(%v == $nexus3){ $nexus3 = %w; }
 else if(%v == $nexus4){ $nexus4 = %w; }
 schedule("deleteObject("@%v@");", 2);
 setpilotid(%w, 30); }

function fiveMinuteWarning()
{
   say(0,20,"<jc><f5>WARNING: Mission ends in 5 minutes.<n>Credits not spent will be lost.","sfx_siren.wav");
}

function onMissionLoad()
{
 storeobject("missiongroup\\ghostgorg", "ghostgorg.gse");
 storeobject("missiongroup\\ghostshep", "ghostshep.gse");
 storeobject("missiongroup\\ghostgoad1", "ghostgoad1.gse");
 storeobject("missiongroup\\ghostgoad2", "ghostgoad2.gse");
 storeobject("missiongroup\\ghostgoad3", "ghostgoad3.gse");
 deleteobject("Missiongroup\\ghostgorg");
 deleteobject("Missiongroup\\ghostshep");
 deleteobject("Missiongroup\\ghostgoad1");
 deleteobject("Missiongroup\\ghostgoad2");
 deleteobject("Missiongroup\\ghostgoad3");
 storeobject("missiongroup\\base\\1", "glitchchicken.gse");
 storeobject("missiongroup\\base\\3", "glitchdogpile.gse");

   cdAudioCycle("SS1", "SS3", "SS4", "Purge");
   setGameInfo("<f2>GAME TYPE:<f0>  Command & Destroy\n\n<f2>CREATOR:<f0>  Gen. Raven [M.I.B.]\n\n<f0>Each player begins with "@$initCredits@" credits. Earn more credits by destroying enemy vehicles and turrets. Then scan the target drone balls at each base or use the HercBoost keymap to select and purchase vehicles, turrets, and other useful items. When you purchase an item, you will recieve information on the full use of that item. \n\n<f2>HERCBOOST KEYMAP CONTROLS:\n\n<f3>CTRL + S = <f0>Toggle Category (Vehicles, Turrets, & Items)\n<f3>CTRL + D = <f0>Cycle forward through the selection menu\n<f3>CTRL + A = <f0>Cycle backwards through the selection menu\n<f3>CTRL + W = <f0>Buy selected item from the current category.\n\n<f2>DOWNLOAD INFO:\n\n<f5>You can download HercBoost keymap, C&D_Circular_Logic, & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getPlayerNum(%i);
      if(%player.group=="")
      {  
         %player.aicount = 0;
         %player.invincible = false;
         %player.extraKills = 0;
         %player.deathdelay = false;
         %player.delay = false;
         %player.credits = $initCredits;
         %player.item = "Reload";
         %player.hasItem = false;
         %player.currentitem = "";
         %player.veh = "Seek";
         %player.turret = "HATC";
         %player.category = "veh";
         %player.attackDelay = false;
         %player.group = newObject("group"@%player, simGroup);
         addToSet("Missiongroup", %player.group);
         %player.turgroup = newObject("GroupOfTurrets", simGroup);
         addToSet(%player.group, %player.turgroup);    
      }
   }
}

function player::onAdd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
   say(%player, 0, "Welcome to Command & Destroy (C&D)! Earn credits by destroying enemy vehicles and turrets. Then scan the target drone balls at each base or use the HercBoost keymap to select and purchase vehicles, turrets, and other useful items. Check the game info tab for more detailed information. This version has several new features and was created by :e: [TA] Ghost Velax @.");
  
   %player.aicount = 0;
   %player.invincible = false;
   %player.extraKills = 0;
   %player.delay = false;
   %player.deathdelay = false;
   %player.credits = $initCredits;
   %player.item = "Reload";
   %player.hasItem = false;
   %player.currentitem = "";
   %player.veh = "Seek";
   %player.turret = "HATC";
   %player.category = "veh";
   %player.attackDelay = false;
   deleteObject(%player.group);
   %player.group = newObject("group"@%player, simGroup);
   addToSet("Missiongroup", %player.group);
   %player.turgroup = newObject("GroupOfTurrets", simGroup);
   addToSet(%player.group, %player.turgroup);
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
   echo(%player.group@" GROUP"@%player@" deleted");
   deleteObject(%player.group);
   %player.group = "";
}

function copyObject(%object,%name)
{
   storeObject(%object, "copyObject.tmp");
   if(%name=="")
   {
      %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   }
   else
   {
      %copy = loadObject(%name, "copyObject.tmp");
   }
   return %copy;
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleidtoplayernum(%vehicleId);
   if(%player!=0)
   {
      %vehicleId.owner = "";
      %player.delay = false;      
      %player.InPad = false;
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      %obj = getNextObject(%player.group,0);
      while(%obj!=0)
      {
         if((getTeam(%player)!=%player.lastteam)&&(getobjectname(%obj)=="veh"))
         {
            setPosition(%obj,5000,5000,-5000);
            setTeam(%obj, getTeam(%player));
            schedule("randomTransport("@%obj@",getPosition("@%vehicleid@",x)-300,getPosition("@%vehicleid@",y)-300,getPosition("@%vehicleid@",x)+300,getPosition("@%vehicleid@",y)+300);",1);
         }
         %obj = getNextObject(%player.group,%obj);
      }
      order("MissionGroup\\group"@%player, guard, %vehicleId);
      reloadObject("MissionGroup\\group"@%player, 5000);
      %player.lastteam = getTeam(%player);
   }
   %vehicleId.hitamine = false;
   if((%player!=0)&&($server::teamplay==true)&&($antiSpawnKill==true))
   {
      %player.invincible = true;
      schedule("resetInvincible("@%player@");",10);      
   }
}

function resetInvincible(%player)
{
   // Player shouldnt be able to die from enemy fire...
   // so this will work correctly unless a player respawns 
   // within 10 secs of spawning.
   %player.invincible = false;
   playSound(%player,"C2_tattadit.wav",IDPRF_2D);
   echo(getname(%player)@" is no longer invincible.");
}
echo("400");
function vehicle::onDestroyed(%destroyed, %destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   %player2.deathdelay = true;
   if(%player == 0 && %destroyer.isglitch == true && $nexusowner != 0){
    %player = $nexusowner; }
   schedule("deathdelay(" @ %player2 @ ");", 5);
   if(%player2==0)
   {
      %him = %destroyed.owner;
      %him.aicount--;
   }
   if((%player!=0)&&(%destroyed!=%destroyer))
   {
      if(%destroyed.owner==%player)
      {
         say(%player,%player,"<f5>You do not recieve credits for destroying your own AI vehicles.");
      }
      else if(%destroyed.isglitch==true && (getteam(%destroyed) == getteam(%destroyer) || getteam(%destroyed) == *IDSTR_TEAM_NEUTRAL) )
      {
         say(%player,%player,"<f5>You do not recieve credits for destroying non-hostile defenders.");
      }
      else
      {
         %name = getVehicleName(%destroyed);
         if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
         {
            %player.credits += 8;
         }
         else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
         {
            %player.credits += 6;
         }
         else
         {
            %player.credits += 5;
         }
      }
   }
   if(%player2==0)
   {
      schedule("deleteObject("@%destroyed@");",2);
   }
   if((%player==0)&&(%destroyer.owner!="")&&(%destroyed.hitamine!=true)&&(%player2!=%destroyer.owner)&&(getTeam(%destroyer)!=getTeam(%destroyed)))
   {
      %owner = %destroyer.owner;
      %owner.extraKills++;
      %name = getVehicleName(%destroyed);
      if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
      {
         %owner.credits += 8;
      }
      else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
      {
         %owner.credits += 6;
      }
      else
      {
         %owner.credits += 5;
      }
   }
   %ksatKill = false;
   if((%player==0)&&(%destroyer == -1)&&(%destroyed.hitamine!=true)&&(%player2!=$lastKSAT))
   {
      %owner = $lastKSAT;
      %name = getVehicleName(%destroyed);
      if(($server::teamplay==true)&&(getTeam(%owner)==getTeam(%destroyed)))
      {
         echo("KSAT TEAMKILL - No points awarded");
      }
      else if(%destroyed.owner==%owner)
      {
         echo("KSAT AI TEAMKILL - No points awarded");
      }
      else
      {
         %owner.extraKills++;
         if((%name=="Apocalypse")||(%name=="Knight's Apocalypse")||(%name=="Gorgon")||(%name=="Knight's Gorgon")||(%name=="Adjudicator")||(%name=="Platinum Guard Adjudicator")||(%name=="Executioner")||(%name=="Platinum Guard Executioner")||(%name=="Olympian"))
         {
            %owner.credits += 8;
         }
         else if((%name=="Basilisk")||(%name=="Knight's Basilisk")||(%name=="Minotaur")||(%name=="Knight's Minotaur")||(%name=="Shepherd")||(%name=="Metagen Shepherd")||(%name=="Disrupter")||(%name=="Knight's Disruptor")||(%name=="Dreadlock")||(%name=="Harabec's Predator")||(%name=="Myrmidon")||(%name=="Knight's Myrmidon"))
         {
            %owner.credits += 6;
         }
         else
         {
            %owner.credits += 5;
         }
      }
      %ksatKill = true;
      say(0,0, getHudName(%destroyed)@" was killed by "@getName(%owner)@"'s K-SAT attack!");
   }
   else if((%player==0)&&(%destroyer == -1)&&(%destroyed.hitamine!=true)&&(%player2==$lastKSAT))
   {
      %ksatKill = true;
      say(0,0, getHudName(%destroyed)@" was killed by his own K-SAT attack!");
   }
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   if((%destroyed.hitamine!=true)&&(%ksatKill!=true))
   {
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
   }   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if((getTeam(%destroyed)==getTeam(%destroyer))&&(%destroyed!=%destroyer))
      {
         antiTeamKill(%destroyer);
      }
   }   
   %destroyed.owner = "";
   %destroyed.hitamine = false;   
}

function deathdelay(%player2)
{
   %player2.deathdelay = false;
}

function vehicle::onmessage(%destroyer,%message,%target)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if((%message=="TargetDestroyed")&&(strAlign(3,l,getObjectName(%target))=="tur"))
   {
      if(%target.owner!=%player)
      {
         %player.credits+=5;
         %player.extraKills++;
      }
      %target.owner = "";
      schedule("deleteObject("@%target@");",2);
   }
}

function vehicle::onattacked(%attacked,%attacker)
{
   %p = playermanager::vehicleIdToPlayerNum(%attacked);
   if(%p.invincible==true)
   {
      healObject(%attacked,99999);
   }
   if(strAlign(3, l, getObjectName(%attacker)) != "tur")
   {
      %player = playermanager::vehicleIdtoPlayerNum(%attacker);
      %player2 = playermanager::vehicleIdtoPlayernum(%attacked);
      if((%player.attackdelay==false)&&(%attacked.owner==%player)&&(%player!=0)&&(%player2==0))
      {
         %player.attackdelay = true;
         say(%player,%player, "<f5>WARNING: You are firing upon your own vehicle!");
         schedule("resetAttack("@%player@");",3);   
      }
   }
}

function resetAttack(%player)
{
   %player.attackDelay = false;
}

function vehicle::onSpot(%spotter,%target)
{
   %player = playermanager::vehicleIdtoPlayerNum(%spotter);
   if(%target!="")
   {
      if((getTeam(%spotter)==getTeam(%target))&&($server::teamplay==true))
      {
         healObject(%spotter, -10000);
         say(%player,%player,"<f4>You cannot spot your teammates.","alarm2.wav");
      }
      else
      {
         order(%player.turgroup, attack, %target);
         say(%player,%player,"<f4>Your turrets have been ordered to attack "@getHudName(%target)@".");
      }
   }
   else
   {
      order(%player.turgroup, attack, 0);
      order(%player.turgroup, clear);
      say(%player,%player,"<f4>Target lost. You must maintain target lock.");
   }
}

function vehicle::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);
   %player2 = playermanager::vehicleidtoplayernum(%scanned);
   if((%player2==0)&&(%scanned.owner==%player))
   {
      order(%scanned,cloak,true);
      if(%scanned.order=="follow")
      {
         %nav = getVehicleNavMarkerId(%scanner);
         if(getPosition(%nav)=="0.000000 0.000000 0.000000")
         {
            say(%player,%player,"<f5>You must set a nav before you can order your AI vehicles.");
         }
         else
         {
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y);
            order(%scanned, guard, %x,%y,%z);
            %scanned.order = "guard";
            say(%player,%player,"<f4>Your AI vehicle is now guarding your nav marker.");
         }
      }
      else
      {
         order(%scanned,guard,%scanner);
         %scanned.order = "follow";
         say(%player,%player,"<f4>Your AI vehicle is now guarding your vehicle.");
      }
   }
   if(%scanned.owner!=%player)
   {
      if(%player.currentitem=="Stasis")
      {
         %player.hasitem = false;
         %field1 = copyObject($itemStasis);
         %field2 = copyObject($itemStasis);
         %field3 = copyObject($itemStasis);
         %field4 = copyObject($itemStasis);
         addToSet(%player.group,%field1);
         addToSet(%player.group,%field2);
         addToSet(%player.group,%field3);
         addToSet(%player.group,%field4);    
         %x = getposition(%scanned,x);
         %y = getposition(%scanned,y);
         %z1 = getTerrainHeight(%x,%y+30)+24;
         %z2 = getTerrainHeight(%x+30,%y)+24;
         %z3 = getTerrainHeight(%x,%y-30)+24;
         %z4 = getTerrainHeight(%x-30,%y)+24;
         setPosition(%field1,%x,%y+30,%z1,90,180);
         setPosition(%field2,%x+30,%y,%z2,0,180);
         setPosition(%field3,%x,%y-30,%z3,90,180);
         setPosition(%field4,%x-30,%y,%z4,0,180);
         say(%player,%player,"<f4>Stasis field deployed.","sfx_electrical_bzzt.wav");
         if(%player2!=0)
         {
            say(%player2,%player2,"<f4>Your vehicle has been temporarily trapped inside a stasis field.","sfx_electrical_bzzt.wav");
         }
         setHudTimer(0,-1,"",3,%player2);
         setHudTimer(60,-1,"Stasis Field:",3,%player2);
         schedule("deleteObject("@%field1@");",60);
         schedule("deleteObject("@%field2@");",60);
         schedule("deleteObject("@%field3@");",60);
         schedule("deleteObject("@%field4@");",60);
         %player.currentitem = "";
      }
      else if(%player.currentitem=="Ion")
      {
         %player.hasitem = false;
         %player.currentitem = "";
         %scannerX = getposition(%scanner,x);
         %scannerY = getposition(%scanner,y);
         %scannerZ = getposition(%scanner,z)+10;
         %scannedX = getposition(%scanned,x);
         %scannedY = getposition(%scanned,y);
         %scannedZ = getposition(%scanned,z);
         droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
         %distance = getdistance(%scanner,%scanned);
         %time = %distance / 400; //400 m/s (speed of drop pod)
         schedule("healObject("@%scanned@",-7500);",%time);
         if(%player2!=0)
         {
            schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
         }
         playSound(%player, "sfx_shrk.wav", IDPRF_2D);
      }
      else if(%player.currentitem=="Stun")
      {
         if(%player2==0)
         {
            say(%player,%player,"<f5>You cannot use this item on an AI vehicle.");
         }
         else
         {            
            %player.hasitem = false;
            %player.currentitem = "";
            playSound(%player,"sfx_cmd.wav",IDPRF_2D);
            say(%player2,%player2,"<f4>You have been hit with a stun grenade.","explo3.wav");
            fadeEvent(%player2,in,20,3,3,3);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",0.5);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",1);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",1.5);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",2);
            schedule("fadeEvent("@%player2@",in,20,3,3,3);",2.5);
            setVehicleSpecialIdentity(%scanned,true,"Yellow");
            schedule("setVehicleSpecialIdentity("@%scanned@",false);",22);
            %count = playermanager::getPlayerCount();
            for(%i = 0; %i < %count; %i++)
            {
               %player3 = playerManager::getPlayerNum(%i);
               %flashed = playerManager::playerNumToVehicleId(%player3);
               if((getDistance(%flashed, %scanned) <= 50) && (%flashed != %scanned))
               {
                  playSound(%player3,"explo3.wav",IDPRF_2D);
                  fadeEvent(%player3, in, 7, 3, 3, 3);
                  setVehicleSpecialIdentity(%flashed, true, "Yellow");
                  schedule("setVehicleSpecialIdentity(" @ %flashed @ ", false);", 7);
               }
            }
         }
      }
      else if(%player.currentitem=="EMP")
      {
         %player.hasitem = false;
         %player.currentitem = "";
         %x = getposition(%scanner,x);
         %y = getposition(%scanner,y);
         %z = getposition(%scanner,z)+3;
         %wave = copyObject($itemWave);
         addToSet(%player.group,%wave);
         schedule("setPosition("@%wave@","@%x@","@%y@","@%z@");",0.5);
         schedule("playAnimSequence("@%wave@",0,true);",0.5);
         schedule("deleteObject("@%wave@");",2.167);
         %count = playermanager::getPlayerCount();
         for(%i = 0; %i < %count; %i++)
         {
            %player3 = playermanager::getplayernum(%i);
            %victim = playermanager::playernumtovehicleId(%player3);
            %distance = getdistance(%scanner,%victim);
            if((%distance<=250)&&(%victim!=%scanner)&&(%victim!=0))
            {
               schedule("empFix("@%player3@");",0.9);
               schedule("empFix("@%player3@");",0.95);
               schedule("empFix("@%player3@");",0.99);
               schedule("say("@%player3@","@%player3@",\"<f4>You were hit by an EMP shockwave! All vehicle operating systems have been temporarily offlined.\");",0.75);
               schedule("violate("@%victim@");",1);
               schedule("reloadObject("@%victim@",5000);",1.25);
               schedule("playSound("@%player3@", \"plasma3.wav\", IDPRF_2D);",1);
               schedule("playSound("@%player3@", \"sfx_prob.wav\", IDPRF_2D);",1);
               schedule("playSound("@%player3@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
            }
         }
         for(%i=8000;%i<10000;%i++)
         {
            %name = getObjectname(%i);
            if((%name=="veh")&&(getDistance(%scanner,%i)<=250))
            {
               schedule("violate("@%i@");",1);
               schedule("order("@%i@",shutdown,true);",1);
               schedule("order("@%i@",shutdown,false);",7);
            }
            else if((strAlign(3,l,%name)=="tur")&&(%i!=$turHATC)&&(%i!=$turEMP)&&(%i!=$turHLAS)&&(%i!=$turHBLAS)&&(%i!=$turHBC)&&(%i!=$turBLINK)&&(%i!=$turELF)&&(%i!=$turMFAC)&&(%i!=$turNIKE)&&(%i!=$turPBW)&&(getDistance(%scanner,%i)<=250))
            {
               schedule("order("@%i@",shutdown,true);",1);
               schedule("order("@%i@",shutdown,false);",11);
            }
         }         
         say(%player,%player,"<f4>Emitting EMP Shockwave...");
         schedule("playSound("@%player@", \"plasma3.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player@", \"sfx_prob.wav\", IDPRF_2D);",1);
         schedule("playSound("@%player@", \"sfx_orbital_gun.wav\", IDPRF_2D);",1);
      }
   }
}

echo("600");

function empFix(%player)
{
   %player.justlaid = true;
}

function remoteBoostSwitch(%player)
{
   if(%player.category=="veh")
   {
      %player.category = "turret";
      say(%player,%player,"<f1>Category: Turrets");
   }
   else if(%player.category=="turret")
   {
      %player.category = "item";
      say(%player,%player,"<f1>Category: Items");
   }
   else if(%player.category=="item")
   {
      %player.category = "veh";
      say(%player,%player,"<f1>Category: Vehicles");
   }
}

function vehicles::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleVeh(%player);
}

echo("800");

function remoteHoverSwitch(%player)
{
   if(%player.category == "veh")
   {
      toggleVeh(%player);
   }
   else if(%player.category == "turret")
   {
      toggleTurret(%player);
   }
   else if(%player.category == "item")
   {
      toggleItem(%player);
   }
}

function remoteCancelSwitch(%player)
{
   if(%player.delay==false)
   {
      if(%player.category == "veh")
      {
         reverseVeh(%player);
      }
      else if(%player.category == "turret")
      {
         reverseTurret(%player);
      }
      else if(%player.category == "item")
      {
         reverseItem(%player);
      }
   }
   %player.delay = false;
}

function toggleVeh(%player)
{
   if(%player.veh=="Ghostpred")
   {
      %player.veh = "Seek";
      say(%player,%player,"<f1>Current Selection: Seeker (7 credits)");
   }   
//   else if(%player.veh=="Seek")
//   {
//      %player.veh = "Talo";
//      say(%player,%player,"<f1>Current Selection: Knight's Talon (12 credits)");
//   }
   else if(%player.veh=="Seek")
   {
      %player.veh = "Goad";
      say(%player,%player,"<f1>Current Selection: Ghost Goad (10 credits)");
   }
   else if(%player.veh=="Goad")
   {
      %player.veh = "Bolo";
      say(%player,%player,"<f1>Current Selection: Recluse (10 credits)");
   }
   else if(%player.veh=="Bolo")
   {
      %player.veh = "Aven";
      say(%player,%player,"<f1>Current Selection: TDF Nike (13 credits)");
   }
   else if(%player.veh=="Aven")
   {
      %player.veh = "Mino";
      say(%player,%player,"<f1>Current Selection: TDF Minotaur (15 credits)");
   }
   else if(%player.veh=="Mino")
   {
      %player.veh = "Eman";
      say(%player,%player,"<f1>Current Selection: Emancipator (15 credits)");
   }
   else if(%player.veh=="Eman")
   {
      %player.veh = "Myrm";
      say(%player,%player,"<f1>Current Selection: TDF Myrmidon (15 credits)");
   }
   else if(%player.veh=="Myrm")
   {
      %player.veh = "Drea";
      say(%player,%player,"<f1>Current Selection: TDF Paladin (15 credits)");
   }
   else if(%player.veh=="Drea")
   {
      %player.veh = "Bike";
      say(%player,%player,"<f1>Current Selection: Pouncer (17 credits)");
   }
   else if(%player.veh=="Bike")
   {
      %player.veh = "Shep";
      say(%player,%player,"<f1>Current Selection: Shepherd (17 credits)");
   }
   else if(%player.veh=="Shep")
   {
      %player.veh = "Disr";
      say(%player,%player,"<f1>Current Selection: TDF Disruptor (17 credits)");
   }
   else if(%player.veh=="Disr")
   {
      %player.veh = "Basl";
      say(%player,%player,"<f1>Current Selection: TDF Basilisk (18 credits)");
   }
   else if(%player.veh=="Basl")
   {
      %player.veh = "Judg";
      say(%player,%player,"<f1>Current Selection: Machinator Adjudicator (20 credits)");
   }
   else if(%player.veh== "Judg")
   {
      %player.veh = "Apoc";
      say(%player,%player,"<f1>Current Selection: TDF Apocalypse (22 credits)");
   }
   else if(%player.veh== "Apoc")
   {
      %player.veh = "Olyp";
      say(%player,%player,"<f1>Current Selection: Olympian (23 credits)");
   }
   else if(%player.veh== "Olyp")
   {
      %player.veh = "Exec";
      say(%player,%player,"<f1>Current Selection: Executioner (25 credits)");
   }
   else if(%player.veh== "Exec")
   {
      %player.veh = "Gorg";
      say(%player,%player,"<f1>Current Selection: TDF Gorgon (25 credits)");
   }
   else if(%player.veh== "Gorg")
   {
      %player.veh = "Clone";
      say(%player,%player,"<f1>Current Selection: Clone your vehicle (25 credits)");
   }
   else if(%player.veh== "Clone")
   {
      %player.veh = "Ghostapoc";
      say(%player,%player,"<f1>Current Selection: Icey's Gorgon (30 credits)");
   }
   else if(%player.veh== "Ghostapoc")
   {
      %player.veh = "Ghostpred";
      say(%player,%player,"<f1>Current Selection: Delithita's Shepherd (35 credits)");
   }
}

function reverseVeh(%player)
{
   if(%player.veh=="Goad")
   {
      %player.veh = "Seek";
      say(%player,%player,"<f1>Current Selection: Seeker (7 credits)");
   }   
//   else if(%player.veh=="Goad")
//   {
//      %player.veh = "Talo";
//      say(%player,%player,"<f1>Current Selection: Knight's Talon (12 credits)");
//   }
   else if(%player.veh=="Bolo")
   {
      %player.veh = "Goad";
      say(%player,%player,"<f1>Current Selection: Ghost Goad (10 credits)");
   }
   else if(%player.veh=="Aven")
   {
      %player.veh = "Bolo";
      say(%player,%player,"<f1>Current Selection: Recluse (10 credits)");
   }
   else if(%player.veh=="Mino")
   {
      %player.veh = "Aven";
      say(%player,%player,"<f1>Current Selection: TDF Nike (13 credits)");
   }
   else if(%player.veh=="Eman")
   {
      %player.veh = "Mino";
      say(%player,%player,"<f1>Current Selection: TDF Minotaur (15 credits)");
   }
   else if(%player.veh=="Myrm")
   {
      %player.veh = "Eman";
      say(%player,%player,"<f1>Current Selection: Emancipator (15 credits)");
   }
   else if(%player.veh=="Drea")
   {
      %player.veh = "Myrm";
      say(%player,%player,"<f1>Current Selection: TDF Myrmidon (15 credits)");
   }
   else if(%player.veh=="Bike")
   {
      %player.veh = "Drea";
      say(%player,%player,"<f1>Current Selection: TDF Paladin (15 credits)");
   }
   else if(%player.veh=="Shep")
   {
      %player.veh = "Bike";
      say(%player,%player,"<f1>Current Selection: Pouncer (17 credits)");
   }
   else if(%player.veh=="Disr")
   {
      %player.veh = "Shep";
      say(%player,%player,"<f1>Current Selection: Shepherd (17 credits)");
   }
   else if(%player.veh=="Basl")
   {
      %player.veh = "Disr";
      say(%player,%player,"<f1>Current Selection: TDF Disruptor (17 credits)");
   }
   else if(%player.veh=="Judg")
   {
      %player.veh = "Basl";
      say(%player,%player,"<f1>Current Selection: TDF Basilisk (18 credits)");
   }
   else if(%player.veh=="Apoc")
   {
      %player.veh = "Judg";
      say(%player,%player,"<f1>Current Selection: Machinator Adjudicator (20 credits)");
   }
   else if(%player.veh== "Olyp")
   {
      %player.veh = "Apoc";
      say(%player,%player,"<f1>Current Selection: TDF Apocalypse (22 credits)");
   }
   else if(%player.veh== "Exec")
   {
      %player.veh = "Olyp";
      say(%player,%player,"<f1>Current Selection: Olympian (23 credits)");
   }
   else if(%player.veh== "Gorg")
   {
      %player.veh = "Exec";
      say(%player,%player,"<f1>Current Selection: Executioner (25 credits)");
   }
   else if(%player.veh== "Clone")
   {
      %player.veh = "Gorg";
      say(%player,%player,"<f1>Current Selection: TDF Gorgon (25 credits)");
   }
   else if(%player.veh== "Ghostapoc")
   {
      %player.veh = "Clone";
      say(%player,%player,"<f1>Current Selection: Clone your vehicle (25 credits)");
   }
   else if(%player.veh== "Ghostpred")
   {
      %player.veh = "Ghostapoc";
      say(%player,%player,"<f1>Current Selection: Icey's Gorgon (30 credits)");
   }
   else if(%player.veh== "Seek")
   {
      %player.veh = "Ghostpred";
      say(%player,%player,"<f1>Current Selection: Delithita's Shepherd (35 credits)");
   }
}

echo("1000");

function turrets::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleTurret(%player);
}

function toggleTurret(%player)
{
   if(%player.turret=="HATC")
   {
      %player.turret = "EMP";
      say(%player,%player,"<f1>Current Selection: 2-EMP Turret (12 credits)");
   }
   else if(%player.turret=="EMP")
   {
      %player.turret = "HLAS";
      say(%player,%player,"<f1>Current Selection: 2-HLAS Turret (13 credits)");
   }
   else if(%player.turret=="HLAS")
   {
      %player.turret = "HBLAS";
      say(%player,%player,"<f1>Current Selection: 2-PBW Turret (15 credits)");
   }
   else if(%player.turret=="HBLAS")
   {
      %player.turret = "HBC";
      say(%player,%player,"<f1>Current Selection: 2-AML Turret (20 credits)");
   }
   else if(%player.turret=="HBC")
   {
      %player.turret = "BLINK";
      say(%player,%player,"<f1>Current Selection: 2-BLINK Turret (20 credits)");
   }
   else if(%player.turret=="BLINK")
   {
      %player.turret = "ELF";
      say(%player,%player,"<f1>Current Selection: 4-Nanite Turret (22 credits)");
   }
   else if(%player.turret=="ELF")
   {
      %player.turret = "MFAC";
      say(%player,%player,"<f1>Current Selection: 2-MFAC Turret (25 credits)");
   }
   else if(%player.turret=="MFAC")
   {
      %player.turret = "NIKE";
      say(%player,%player,"<f1>Current Selection: Artillery Turret (25 credits)");
   }
   else if(%player.turret=="NIKE")
   {
      %player.turret = "PBW";
      say(%player,%player,"<f1>Current Selection: 4-Shrike Turret (28 credits)");
   }
   else if(%player.turret=="PBW")
   {
      %player.turret = "HATC";
      say(%player,%player,"<f1>Current Selection: 2-EMC Turret (10 credits)");
   }
}

function reverseTurret(%player)
{
   if(%player.turret=="HLAS")
   {
      %player.turret = "EMP";
      say(%player,%player,"<f1>Current Selection: 2-EMP Turret (12 credits)");
   }
   else if(%player.turret=="HBLAS")
   {
      %player.turret = "HLAS";
      say(%player,%player,"<f1>Current Selection: 2-HLAS Turret (13 credits)");
   }
   else if(%player.turret=="HBC")
   {
      %player.turret = "HBLAS";
      say(%player,%player,"<f1>Current Selection: 2-PBW Turret (15 credits)");
   }
   else if(%player.turret=="BLINK")
   {
      %player.turret = "HBC";
      say(%player,%player,"<f1>Current Selection: 2-AML Turret (20 credits)");
   }
   else if(%player.turret=="ELF")
   {
      %player.turret = "BLINK";
      say(%player,%player,"<f1>Current Selection: 2-BLINK Turret (20 credits)");
   }
   else if(%player.turret=="MFAC")
   {
      %player.turret = "ELF";
      say(%player,%player,"<f1>Current Selection: 4-Nanite Turret (22 credits)");
   }
   else if(%player.turret=="NIKE")
   {
      %player.turret = "MFAC";
      say(%player,%player,"<f1>Current Selection: 2-MFAC Turret (25 credits)");
   }
   else if(%player.turret=="PBW")
   {
      %player.turret = "NIKE";
      say(%player,%player,"<f1>Current Selection: Artillery Turret (25 credits)");
   }
   else if(%player.turret=="HATC")
   {
      %player.turret = "PBW";
      say(%player,%player,"<f1>Current Selection: 4-Shrike Turret (28 credits)");
   }
   else if(%player.turret=="EMP")
   {
      %player.turret = "HATC";
      say(%player,%player,"<f1>Current Selection: 2-EMC Turret (10 credits)");
   }
}

function items::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   toggleItem(%player);
}

function toggleItem(%player)
{
   if(%player.item=="Attack")
   {
      %player.item = "Reload";
      say(%player,%player,"<f1>Current Selection: Instant Reload (3 credits)");
   }
   else if(%player.item=="Reload")
   {
      %player.item = "NavPort";
      say(%player,%player,"<f1>Current Selection: Teleport to your nav marker (5 credits)");
   }
   else if(%player.item=="NavPort")
   {
      %player.item = "Field";
      say(%player,%player,"<f1>Current Selection: Basic Forward Point Base (55 credits)");
   }
   else if(%player.item=="Field")
   {
      %player.item = "Stun";
      say(%player,%player,"<f1>Current Selection: Advanced Forward Point Base (75 credits)");
   }
   else if(%player.item=="Stun")
   {
      %player.item = "Prox";
      say(%player,%player,"<f1>Current Selection: Snare (7 credits)");
   }
   else if(%player.item=="Prox")
   {
      %player.item = "Stasis";
      say(%player,%player,"<f1>Current Selection: Stasis Field (10 credits)");
   }   
   else if(%player.item=="Stasis")
   {
      %player.item = "Ion";
      say(%player,%player,"<f1>Current Selection: Ion Cannon (12 credits)");
   }
   else if(%player.item=="Ion")
   {
      %player.item = "EMP";
      say(%player,%player,"<f1>Current Selection: EMP Shockwave Generator (13 credits)");
   }
   else if(%player.item=="EMP")
   {
      %player.item = "Repair";
      say(%player,%player,"<f1>Current Selection: Instant Repair/Reload (13 credits)");
   }
   else if(%player.item=="Repair")
   {
      %player.item = "Ammo";
      say(%player,%player,"<f1>Current Selection: Reload Pad (15 credits)");
   }   
   else if(%player.item=="Ammo")
   {
      %player.item = "Heal";
      say(%player,%player,"<f1>Current Selection: Repair Pad (18 credits)");
   }
   else if(%player.item=="Heal")
   {
      %player.item = "Zen";
      say(%player,%player,"<f1>Current Selection: Repair/Reload Pad (20 credits)");
   }
   else if(%player.item=="Zen")
   {
      %player.item = "Stealth";
      say(%player,%player,"<f1>Current Selection: Nexus Hack (25 credits)");
   }
   else if(%player.item=="Stealth")
   {
      %player.item = "Haunt";
      say(%player,%player,"<f1>Current Selection: Haunt (40 credits)");
   }
   else if(%player.item=="Haunt")
   {
      %player.item = "KSAT";
      say(%player,%player,"<f1>Current Selection: Killer Satellite Strike [K-SAT] (50 credits)");
   }
   else if(%player.item=="KSAT")
   {
      %player.item = "Sell";
      say(%player,%player,"<f1>Current Selection: Sell your current item for half price.");
   }
   else if(%player.item=="Sell")
   {
      %player.item = "Follow";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard you. (Free)");
   }
   else if(%player.item=="Follow")
   {
      %player.item = "Guard";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard your nav marker. (Free)");
   }
   else if(%player.item=="Guard")
   {
      %player.item = "Attack";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to attack your target. (Free)");
   }
}

echo("1200");

function reverseItem(%player)
{
   if(%player.item=="NavPort")
   {
      %player.item = "Reload";
      say(%player,%player,"<f1>Current Selection: Instant Reload (3 credits)");
   }
   else if(%player.item=="Field")
   {
      %player.item = "NavPort";
      say(%player,%player,"<f1>Current Selection: Teleport to your nav marker (5 credits)");
   }
   else if(%player.item=="Stun")
   {
      %player.item = "Field";
      say(%player,%player,"<f1>Current Selection: Basic Forward Point Base (55 credits)");
   }
   else if(%player.item=="Prox")
   {
      %player.item = "Stun";
      say(%player,%player,"<f1>Current Selection: Advanced Forward Point Base (75 credits)");
   }
   else if(%player.item=="Stasis")
   {
      %player.item = "Prox";
      say(%player,%player,"<f1>Current Selection: Snare (7 credits)");
   }
   else if(%player.item=="Ion")
   {
      %player.item = "Stasis";
      say(%player,%player,"<f1>Current Selection: Stasis Field (10 credits)");
   }   
   else if(%player.item=="EMP")
   {
      %player.item = "Ion";
      say(%player,%player,"<f1>Current Selection: Ion Cannon (12 credits)");
   }
   else if(%player.item=="Repair")
   {
      %player.item = "EMP";
      say(%player,%player,"<f1>Current Selection: EMP Shockwave Generator (13 credits)");
   }
   else if(%player.item=="Ammo")
   {
      %player.item = "Repair";
      say(%player,%player,"<f1>Current Selection: Instant Repair/Reload (13 credits)");
   }
   else if(%player.item=="Heal")
   {
      %player.item = "Ammo";
      say(%player,%player,"<f1>Current Selection: Reload Pad (15 credits)");
   }   
   else if(%player.item=="Zen")
   {
      %player.item = "Heal";
      say(%player,%player,"<f1>Current Selection: Repair Pad (18 credits)");
   }
   else if(%player.item=="Stealth")
   {
      %player.item = "Zen";
      say(%player,%player,"<f1>Current Selection: Repair/Reload Pad (20 credits)");
   }
   else if(%player.item=="Haunt")
   {
      %player.item = "Stealth";
      say(%player,%player,"<f1>Current Selection: Nexus Hack (25 credits)");
   }
   else if(%player.item=="KSAT")
   {
      %player.item = "Haunt";
      say(%player,%player,"<f1>Current Selection: Haunt (40 credits)");
   }
   else if(%player.item=="Sell")
   {
      %player.item = "KSAT";
      say(%player,%player,"<f1>Current Selection: Killer Satellite Strike [K-SAT] (50 credits)");
   }
   else if(%player.item=="Follow")
   {
      %player.item = "Sell";
      say(%player,%player,"<f1>Current Selection: Sell your current item for half price.");
   }
   else if(%player.item=="Guard")
   {
      %player.item = "Follow";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard you. (Free)");
   }
   else if(%player.item=="Attack")
   {
      %player.item = "Guard";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to guard your nav marker. (Free)");
   }
   else if(%player.item=="Reload")
   {
      %player.item = "Attack";
      say(%player,%player,"<f1>Current Selection: Order all of your AI vehicles to attack your target. (Free)");
   }
}

function buyveh::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyVeh(%player, "Scan");
}

function remoteForwardSwitch(%player)
{
   %player.delay = true;
   if(%player.category == "veh")
   {
      buyVeh(%player, "HercBoost");
   }
   else if(%player.category == "turret")
   {
      buyTurret(%player);
   }
   else if(%player.category == "item")
   {
      buyItem(%player);
   }
}

echo("1400");

function hasMoney(%cost,%player)
{
   if(%player.credits>=%cost)
   {
      %player.credits -= %cost;
      return true;
   }
   else
   {
      say(%player,%player, "<f5>You only have "@%player.credits@" credits! That item requires "@%cost@" credits. Earn more credits by making kills.","alarm2.wav");
      return false;
   }
}

function buyVeh(%player, %method)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   %veh = "";
   %target = getTargetId(%vehicleId);
   if(%player.veh=="Clone")
   {
      if(hasMoney(25,%player)==true)
      {
         %veh = copyObject(%vehicleId,"veh");
      }
   } 
   else if(%player.veh=="Target")
   {
      if(%method == "Scan")
      {
         say(%player,%player,"<f5>This item requires the HercBoost keymap to purchase. You can download the keymap from www.starsiegemeninblack.cjb.net.");
      }
      else
      {
         if(%target=="")
         {
            say(%player,%player,"<f5>You do not have a target to clone!");
         }
         else
         {
            if(getVehicleName(%target)==false)
            {
               say(%player,%player,"<f5>Your target must be a vehicle!");
            }
            else
            {
               if(hasMoney(25,%player)==true)
               {
                  %veh = copyObject(%target,"veh");
               }
            }
         }
      }
   }   
   else if(%player.veh=="Seek")
   {
      if(hasMoney(7,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 20);
      }
   }
//   else if(%player.veh=="Talo")
//   {
//      if(hasMoney(12,%player)==true)
//      {
//         %veh = newObject("Veh", "Herc", 13);
//      }
//   }
   else if(%player.veh=="Goad")
   {
      if(hasMoney(10,%player)==true)
      {
         %which = randomint(1,3);
         if(%which == 1){ %veh = loadObject("Veh", "ghostgoad1.gse"); }
         if(%which == 2){ %veh = loadObject("Veh", "ghostgoad2.gse"); }
         if(%which == 3){ %veh = loadObject("Veh", "ghostgoad3.gse"); }
      }
   }
   else if(%player.veh=="Bolo")
   {
      if(hasMoney(10,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 26);
      }   
   }
   else if(%player.veh=="Aven")
   {
      if(hasMoney(13,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 133);
      }   
   }
   else if(%player.veh=="Mino")
   {
      if(hasMoney(15,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 2);
      }   
   }
   else if(%player.veh=="Eman")
   {
      if(hasMoney(15,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 30);
      }   
   }
   else if(%player.veh=="Myrm")
   {
      if(hasMoney(15,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 7);
      }   
   }
   else if(%player.veh=="Drea")
   {
      if(hasMoney(15,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 6);
      }    
   }
   else if(%player.veh=="Bike")
   {
      if(hasMoney(17,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 138);
      }    
   }
   else if(%player.veh=="Shep")
   {
      if(hasMoney(17,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 22);
      }   
   }
   else if(%player.veh=="Disr")
   {
      if(hasMoney(17,%player)==true)
      {
         %veh = newObject("Veh", "Tank", 8);
      }   
   }
   else if(%player.veh=="Basl")
   {
      if(hasMoney(18,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 5);
      }   
   }
   else if(%player.veh== "Judg")
   {
      if(hasMoney(20,%player)==true)
      {
         %veh = loadObject("Veh", "glitchchicken.gse");
         %veh.isglitch = false;
      }   
   }
   else if(%player.veh== "Apoc")
   {
      if(hasMoney(22,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 1);
      }   
   }
   else if(%player.veh== "Olyp")
   {
      if(hasMoney(23,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 33);
      }   
   }
   else if(%player.veh== "Exec")
   {
      if(hasMoney(25,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 24);
      }   
   }
   else if(%player.veh== "Gorg")
   {
      if(hasMoney(25,%player)==true)
      {
         %veh = newObject("Veh", "Herc", 3);
      }
   }
   else if(%player.veh== "Ghostapoc")
   {
      if(hasMoney(30,%player)==true)
      {
         %veh = loadObject("Veh", "ghostgorg.gse");
         setvehicleradarvisible(%veh, false);
      }
   }
   else if(%player.veh== "Ghostpred")
   {
      if(hasMoney(35,%player)==true)
      {
         %veh = loadObject("Veh", "ghostshep.gse");
         setvehicleradarvisible(%veh, false);
      }
   }
   if(%veh!="")
   {
      addToSet("Missiongroup\\group"@%player, %veh);      
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%veh, getTeam(%vehicleId));
      if(%player.veh != "Ghostpred" && %player.veh != "Ghostapoc"){ setPilotId(%veh, 28); }
      else{ setPilotId(%veh, 29); }
      if(%player.veh=="Goad"){ setpilotid(%veh, %which + 30); }
      order(%veh, guard, %vehicleId);
      order(%veh, speed, high);      
      %x1 = getposition(%vehicleId,x)-200;
      %x2 = getposition(%vehicleId,x)+200;
      %y1 = getposition(%vehicleId,y)-200;
      %y2 = getposition(%vehicleId,y)+200;
      randomTransport(%veh,%x1,%y1,%x2,%y2);
      %player.aicount++;
      if(%player.veh=="Clone")
      {
         say(%player,%player,"<f4>Thank you for purchasing a clone of your vehicle! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining.");
      }
      else if(%player.veh=="Target")
      {
         say(%player,%player,"<f4>Thank you for purchasing a clone of "@getHudName(%target)@"! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining.");
      }
      else
      {
       if(%player.veh != "Ghostpred" &&  %player.veh != "Ghostapoc" &&  %player.veh != "Goad" &&  %player.veh != "Judg"){ say(%player,%player,"<f4>Thank you for purchasing a "@getVehiclename(%veh)@"! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining."); }
       if(%player.veh == "Ghostapoc"){ say(%player,%player,"<f4>Thank you for purchasing Icey's Gorgon! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining."); }
       if(%player.veh == "Ghostpred"){
        say(%player,%player,"<f4>Thank you for purchasing Delithita's Shepherd! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining.");
        setPilotId(%veh, 34); }
       if(%player.veh == "Judg"){ say(%player,%player,"<f4>Thank you for purchasing a Machinator Adjudicator! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining."); }
       if(%player.veh == "Goad"){ say(%player,%player,"<f4>Thank you for purchasing a Ghost Goad! Scan it to give it orders. AI vehicles can be repaired/reloaded by ordering them to go to a pad. You have "@%player.credits@" credits remaining."); }
      }
      %veh.owner = %player;
      %veh.order = "follow";
      echo(%player@" "@getname(%player)@" purchased vehicle: "@%player.veh);
   }
}

echo("1600");

function buyturret::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyTurret(%player);
}

function buyTurret(%player)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   %tur = "";
   %nav = getVehicleNavMarkerId(%vehicleId);
   if($server::teamplay==true)
   {
      if(getPosition(%nav)=="0.000000 0.000000 0.000000")
      {
         %thing = %vehicleId;
      }
      else
      {
         %thing = %nav;
      }
      if((getTeam(%player)!="Yellow Team")&&(getDistance(%thing, $navYellow)<=500))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 500 meters of an enemy base!");
         return;
      }
      if((getTeam(%player)!="Blue Team")&&(getDistance(%thing, $navBlue)<=500))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 500 meters of an enemy base!");
         return;
      }
      if((getTeam(%player)!="Red Team")&&(getDistance(%thing, $navRed)<=500))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 500 meters of an enemy base!");
         return;
      }
      if((getTeam(%player)!="Purple Team")&&(getDistance(%thing, $navPurple)<=500))
      {
         say(%player, %player, "<f5>You cannot deploy turrets within 500 meters of an enemy base!");
         return;
      }
   }
   if(%player.turret=="HATC")
   {
      if(hasMoney(10,%player)==true)
      {
         %tur = copyObject($turHATC);
         setStaticShapeShortName(%tur,getName(%player)@"'s EMC Turret");
      }
   }
   else if(%player.turret=="EMP")
   {
      if(hasMoney(12,%player)==true)
      {
         %tur = copyObject($turEMP);
         setStaticShapeShortName(%tur,getName(%player)@"'s EMP Turret");
      }
   }
   else if(%player.turret=="HLAS")
   {
      if(hasMoney(13,%player)==true)
      {
         %tur = copyObject($turHLAS);
         setStaticShapeShortName(%tur,getName(%player)@"'s HLAS Turret");
      }
   }
   else if(%player.turret=="HBLAS")
   {
      if(hasMoney(15,%player)==true)
      {
         %tur = copyObject($turHBLAS);
         setStaticShapeShortName(%tur,getName(%player)@"'s PBW Turret");
      }
   }
   else if(%player.turret=="HBC")
   {
      if(hasMoney(20,%player)==true)
      {
         %tur = copyObject($turHBC);
         setStaticShapeShortName(%tur,getName(%player)@"'s AML Turret");
      }
   }
   else if(%player.turret=="BLINK")
   {
      if(hasMoney(20,%player)==true)
      {
         %tur = copyObject($turBLINK);
         setStaticShapeShortName(%tur,getName(%player)@"'s BLINK Turret");
      }
   }
   else if(%player.turret=="ELF")
   {
      if(hasMoney(22,%player)==true)
      {
         %tur = copyObject($turELF);
         setStaticShapeShortName(%tur,getName(%player)@"'s Nanite Turret");
      }
   }
   else if(%player.turret=="MFAC")
   {
      if(hasMoney(25,%player)==true)
      {
         %tur = copyObject($turMFAC);
         setStaticShapeShortName(%tur,getName(%player)@"'s MFAC Turret");
      }
   }
   else if(%player.turret=="NIKE")
   {
      if(hasMoney(25,%player)==true)
      {
         %tur = copyObject($turNIKE);
         setStaticShapeShortName(%tur,getName(%player)@"'s Artillery Turret");
      }
   }
   else if(%player.turret=="PBW")
   {
      if(hasMoney(28,%player)==true)
      {
         %tur = copyObject($turPBW);
         setStaticShapeShortName(%tur,getName(%player)@"'s Shrike Turret");
      }
   }
   if(%tur!="")
   {
      addToSet(%player.turgroup, %tur);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%tur, getTeam(%vehicleId));
      %tur.owner = %player;
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         %x1 = getposition(%vehicleId,x)-200;
         %x2 = getposition(%vehicleId,x)+200;
         %y1 = getposition(%vehicleId,y)-200;
         %y2 = getposition(%vehicleId,y)+200;
         %x = randomInt(%x1, %x2);
         %y = randomInt(%y1, %y2);
         %z = getTerrainHeight(%x, %y);
         setposition(%tur,%x,%y,%z);
         say(%player,%player,"<f4>Thank you for purchasing a turret! Because you have not placed a nav marker, your turret has been built nearby. You can order your turrets to attack your target by spotting it with LTADs. You have "@%player.credits@" credits remaining.");
      }
      else
      {
         %nav = getVehicleNavMarkerId(%vehicleId);
         %x = getposition(%nav,x);
         %y = getposition(%nav,y);
         %z = getTerrainHeight(%x,%y);
         setPosition(%tur,%x,%y,%z);
         say(%player,%player,"<f4>Thank you for purchasing a turret! It has been built at your nav marker. You can order your turrets to attack your target by spotting it with LTADs. You have "@%player.credits@" credits remaining.");
      }      
      echo(%player@" "@getname(%player)@" purchased turret: "@%player.turret);
   }
}

echo("1800");

function buyitem::structure::onscan(%scanned,%scanner)
{
   %player = playermanager::vehicleIdtoPlayerNum(%scanner);   
   buyItem(%player);
}

function buyItem(%player)
{
   %vehicleId = playermanager::playernumtovehicleid(%player);
   if(%player.item=="Reload")
   {
      if(hasMoney(3,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         reloadObject(%vehicleId,50000);
         say(%player,%player, "<f4>Your ammunition has been replenished. You have "@%player.credits@" credits remaining.","reload_complete.wav");
      }
   }
   else if(%player.item=="NavPort")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where you want to teleport.");
      }
      else
      {
         if(hasMoney(5,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)+20;
            setPosition(%vehicleId,%x,%y,%z);
            say(%player,%player, "<f4>Your vehicle has been transported to your nav marker. You have "@%player.credits@" credits remaining.");
         }
      }
   }
   else if(%player.item=="Field")
   {
         if(getPosition(getVehicleNavMarkerId(%vehicleId),x) <= 4000 || getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>Please place a nav marker in a valid location to establish your FPB.  FPBs can only be established in the Nav Omega region.");
         return;
      }
    if(hasMoney(55,%player)==true)      {
      echo(%player@" "@getname(%player)@" purchased item: BFPB");
      say(%player,%player, "<f4>Thank you for purchasing a Basic Forward Point Base. You have "@%player.credits@" credits remaining.");
      %trig = copyObject($itemHeal);
      %pad = newObject("Item",StaticInterior,"hhealt.dis");
      addToSet(%player.group,%trig);
      addToSet(%player.group,%pad);
      %nav = getVehicleNavMarkerId(%vehicleId);
      %x = getposition(%nav,x);
      %y = getposition(%nav,y);
      %z = getTerrainHeight(%x,%y)-5;
      setPosition(%pad,%x,%y,%z);
      setPosition(%trig,%x,%y,%z);
      %ball = copyObject($itembuyitem);
      setposition(%ball, %x, %y, %z);
      %tur = copyObject($turHblas);
      setStaticShapeShortName(%tur,getName(%player)@"'s FPB Turret");
      addToSet(%player.turgroup, %tur);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%tur, getTeam(%vehicleId));
      %tur.owner = %player;
      %y = %y+60;
      %z = getTerrainHeight(%x,%y);
      setPosition(%tur,%x,%y,%z);
      %which = randomint(1,3);
      if(%which == 1){ %veh = loadObject("Veh", "ghostgoad1.gse"); }
      if(%which == 2){ %veh = loadObject("Veh", "ghostgoad2.gse"); }
      if(%which == 3){ %veh = loadObject("Veh", "ghostgoad3.gse"); }
      addToSet("Missiongroup\\group"@%player, %veh);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%veh, getTeam(%vehicleId));
      setpilotid(%veh, %which + 30);
      order(%veh, guard, %nav);
      order(%veh, speed, high);
      %player.aicount++;
      %veh.owner = %player;
      %veh.order = "follow";
      setPosition(%veh,%x,%y+30,%z+100);
         }
   }
   else if(%player.item=="Stun")
   {
         if(getPosition(getVehicleNavMarkerId(%vehicleId),x) <= 4000 || getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>Please place a nav marker in a valid location to establish your FPB.  FPBs can only be established in the Nav Omega region.");
         return;
      }
     if(hasMoney(75,%player)==true){
      echo(%player@" "@getname(%player)@" purchased item: AFPB");
      say(%player,%player, "<f4>Thank you for purchasing an Advanced Forward Point Base. You have "@%player.credits@" credits remaining.");
      %pad = copyObject($itemKinetron);
      addToSet(%player.group,%pad);
      %pad.owner=%player;
      %nav = getVehicleNavMarkerId(%vehicleId);
      %x = getposition(%nav,x);
      %y = getposition(%nav,y);
      %z = getTerrainHeight(%x,%y);
      setPosition(%pad,%x+5,%y,%z+1);
      %ball = copyobject($itembuytur);
      setposition(%ball, %x, %y - 2, %z);
      %ball2 = copyobject($itembuyveh);
      setposition(%ball2, %x, %y + 2, %z);
      %trig = copyObject($itemZen);
      %pad = newObject("Item",StaticInterior,"hhealt.dis");
      addToSet(%player.group,%trig);
      addToSet(%player.group,%pad);
      %x = %x - 30;
      %z = getTerrainHeight(%x,%y)-5;
      setPosition(%pad,%x,%y,%z);
      setPosition(%trig,%x,%y,%z);
      %tur = copyObject($turPBW);
      setStaticShapeShortName(%tur,getName(%player)@"'s FPB Turret");
      addToSet(%player.turgroup, %tur);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%tur, getTeam(%vehicleId));
      %tur.owner = %player;
      %y = %y+60;
      %z = getTerrainHeight(%x,%y);
      setPosition(%tur,%x,%y,%z);
      %which = randomint(1,3);
      if(%which == 1){ %veh = loadObject("Veh", "ghostgoad1.gse"); }
      if(%which == 2){ %veh = loadObject("Veh", "ghostgoad2.gse"); }
      if(%which == 3){ %veh = loadObject("Veh", "ghostgoad3.gse"); }
      addToSet("Missiongroup\\group"@%player, %veh);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%veh, getTeam(%vehicleId));
      setpilotid(%veh, %which + 30);
      order(%veh, guard, %nav);
      order(%veh, speed, high);
      %player.aicount++;
      %veh.owner = %player;
      %veh.order = "follow";
      setPosition(%veh,%x,%y+30,%z+100);
      %which = randomint(1,3);
      if(%which == 1){ %veh2 = loadObject("Veh", "ghostgoad1.gse"); }
      if(%which == 2){ %veh2 = loadObject("Veh", "ghostgoad2.gse"); }
      if(%which == 3){ %veh2 = loadObject("Veh", "ghostgoad3.gse"); }
      addToSet("Missiongroup\\group"@%player, %veh2);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%veh2, getTeam(%vehicleId));
      setpilotid(%veh2, %which + 30);
      order(%veh2, guard, %nav);
      order(%veh2, speed, high);
      %player.aicount++;
      %veh2.owner = %player;
      %veh2.order = "follow";
      setPosition(%veh2,%x,%y-60,%z+100); }
 }
   else if(%player.item=="Prox")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(7,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: Snare");
            %player.hasitem = true;
            %player.currentItem = "Prox";
            say(%player,%player, "<f4>Thank you for purchasing a Snare. Shut down to deploy it. You have "@%player.credits@" credits remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Stasis")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(10,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "Stasis";
            say(%player,%player, "<f4>Thank you for purchasing a stasis field generator. Scan an enemy vehicle to trap them inside a stasis field for 60 seconds. Shut down to create a protective stasis field around your vehicle. You have "@%player.credits@" credits remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Repair")
   {
      if(hasMoney(13,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         healObject(%vehicleId,50000);
         reloadObject(%vehicleId,50000);
         say(%player,%player, "<f4>Your vehicle has been fully repaired and reloaded. You have "@%player.credits@" credits remaining.","repairs_complete.wav");
      }
   }
   else if(%player.item=="Ammo")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(15,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemAmmo);
            %pad = newObject("Item",StaticInterior,"hammot.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a reload pad. It has been built at your nav marker. You have "@%player.credits@" credits remaining.");
         }
      }    
   }
   else if(%player.item=="Ion")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(12,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "Ion";
            say(%player,%player, "<f4>Thank you for purchasing an ion cannon. Scan an enemy vehicle to fire it. You have "@%player.credits@" credits remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="EMP")
   {
      if(%player.hasItem==false)
      {
         if(hasMoney(13,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %player.hasitem = true;
            %player.currentItem = "EMP";
            say(%player,%player, "<f4>Thank you for purchasing an EMP shockwave generator. Scan an enemy vehicle to use. It will temporarily disable all electronic systems on any vehicle or turret within a 250 meter radius. You have "@%player.credits@" credits remaining.");
         }
      }
      else
      {
         say(%player,%player, "<f5>You can only carry 1 deployable item at a time. Use or sell your current item.");
      }
   }
   else if(%player.item=="Heal")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(18,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemHeal);
            %pad = newObject("Item",StaticInterior,"hhealt.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a repair pad. It has been built at your nav marker. You have "@%player.credits@" credits remaining.");
         }
      }   
   }
   else if(%player.item=="Zen")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify where the pad should be built.");
      }
      else
      {
         if(hasMoney(20,%player)==true)
         {
            echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
            %trig = copyObject($itemZen);
            %pad = newObject("Item",StaticInterior,"hhealt.dis");
            addToSet(%player.group,%trig);
            addToSet(%player.group,%pad);
            %nav = getVehicleNavMarkerId(%vehicleId);
            %x = getposition(%nav,x);
            %y = getposition(%nav,y);
            %z = getTerrainHeight(%x,%y)-5;
            setPosition(%pad,%x,%y,%z);
            setPosition(%trig,%x,%y,%z);
            say(%player,%player, "<f4>Thank you for purchasing a repair/reload pad. It has been built at your nav marker. You have "@%player.credits@" credits remaining.");
         }
      }   
   }
   else if(%player.item=="Stealth")
   {
      if(hasMoney(25,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: Nexus Hack");
         setVehicleRadarVisible(%vehicleId,false);
         %t = 100 - $nexus;
         say(%player,%player, "<f4>Nexus has been hacked!  Nexus will be reset in "@%t@" seconds. You have "@%player.credits@" credits remaining.","bc_mfd.wav");
         %t = getTeam(%player);
         setteam($nexus1, %t);
         setteam($nexus2, %t);
         setteam($nexus3, %t);
         setteam($nexus4, %t);
         order($nexus1, guard, %vehicleid);
         order($nexus2, guard, %vehicleid);
         order($nexus3, guard, %vehicleid);
         order($nexus4, guard, %vehicleid);
         $nexusowner = %player;
      }
   }
   else if(%player.item=="Haunt")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify the coordinates for the Haunt.");
         return;
      }
      if(hasMoney(40,%player)==true)
      {
         echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
         %this = loadobject("ghost", "ghostgorg.gse");
         setPosition(%this, getPosition(getVehicleNavMarkerId(%vehicleId), x), getPosition(getVehicleNavMarkerId(%vehicleId), y)-20, getPosition(getVehicleNavMarkerId(%vehicleId), z) + 30);
         setTeam(%this, getTeam(%player));
         setVehicleRadarVisible(%this,false);
         setPilotid(%this, 29);
         %this.owner = %player;
         addToSet("Missiongroup\\group"@%player, %this);
         schedule("deleteObject("@%this@");", 30);
         %this = loadobject("ghost", "ghostshep.gse");
         setPosition(%this, getPosition(getVehicleNavMarkerId(%vehicleId), x)+20, getPosition(getVehicleNavMarkerId(%vehicleId), y), getPosition(getVehicleNavMarkerId(%vehicleId), z) + 30);
         setTeam(%this, getTeam(%player));
         setVehicleRadarVisible(%this,false);
         setPilotid(%this, 34);
         %this.owner = %player;
         addToSet("Missiongroup\\group"@%player, %this);
         schedule("deleteObject("@%this@");", 30);
         %this = loadobject("ghost", "ghostgoad1.gse");
         setPosition(%this, getPosition(getVehicleNavMarkerId(%vehicleId), x)-20, getPosition(getVehicleNavMarkerId(%vehicleId), y), getPosition(getVehicleNavMarkerId(%vehicleId), z) + 30);
         setTeam(%this, getTeam(%player));
         setVehicleRadarVisible(%this,false);
         setPilotid(%this, 31);
         %this.owner = %player;
         addToSet("Missiongroup\\group"@%player, %this);
         schedule("deleteObject("@%this@");", 30);
         %this = loadobject("ghost", "ghostgoad2.gse");
         setPosition(%this, getPosition(getVehicleNavMarkerId(%vehicleId), x), getPosition(getVehicleNavMarkerId(%vehicleId), y)+20, getPosition(getVehicleNavMarkerId(%vehicleId), z) + 30);
         setTeam(%this, getTeam(%player));
         setVehicleRadarVisible(%this,false);
         setPilotid(%this, 32);
         %this.owner = %player;
         addToSet("Missiongroup\\group"@%player, %this);
         schedule("deleteObject("@%this@");", 30);
         say(%player,%player, "<f4>The Ghosts haunt... You have "@%player.credits@" credits remaining.","sfx_quake.wav");
         say(0,0,"<f5>The Ghosts haunt... beware!", "sfx_quake.wav");
      }
   }
   else if(%player.item=="KSAT")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify the coordinates for the K-SAT attack.");
      }
      else
      {
         if($lastKSAT=="")
         {
            if(hasMoney(50,%player)==true)
            {
               echo(%player@" "@getname(%player)@" purchased item: "@%player.item);
               $lastKSAT=%player;
               %wave = copyObject($itemWave);
               addToset(%player.group,%wave);
               %nav = getVehicleNavMarkerId(%vehicleId);
               %x = getposition(%nav,x);
               %y = getposition(%nav,y);
               %z = getTerrainHeight(%x,%y);               
               say(0,83,"<f5>WARNING: K-SAT activation detected.","warn_missl_lock.wav");
               schedule("flushChannel(83);",0.65);
               setHudTimer(10,-1,"K-SAT Aligning:",2,%player);
               playSound(0,"sfx_quake.wav",IDPRF_2D);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",3);
               schedule("setPosition($ksatBeam,"@%x@","@%y@","@%z@"-100);",5);
               schedule("playSound(0,\"plasma3.wav\",IDPRF_2D);",5);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",6);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",7);
               schedule("dropPod("@%x@","@%y@","@%z+800@","@%x@","@%y@","@%z@");",8);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",8);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",9);
               schedule("playSound(0,\"sfx_prob.wav\",IDPRF_2D);",10);
               schedule("playSound(0,\"sfx_fog.wav\",IDPRF_2D);",10);
               schedule("playSound(0,\"sfx_thunder1.wav\",IDPRF_2D);",10);
               schedule("playSound(0,\"sfx_thunder2.wav\",IDPRF_2D);",10);
               schedule("setPosition("@%wave@","@%x@","@%y@","@%z+3@");",9.5);
               schedule("damageArea("@%wave@",0,0,0,300,999999999);",10.5);
               schedule("damageArea("@%wave@",75,0,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",-75,0,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",0,75,0,100,999999999);",10.5);
               schedule("damageArea("@%wave@",0,-75,0,100,999999999);",10.5);
               schedule("playAnimSequence("@%wave@",0,true);",9.5);
               schedule("deleteObject("@%wave@");",11.667);
               schedule("playSound(0,\"sfx_quake.wav\",IDPRF_2D);",12);
               schedule("playSound(0,\"sfx_thunder1.wav\",IDPRF_2D);",12);
               schedule("setposition($ksatBeam,10000,10000,-10000);",14);
               schedule("$lastKSAT=\"\";",15);
            }
         }
         else
         {
            say(%player,%player,"<f4>Satellite is busy. Try again later.");
         }
      }
   }
   else if(%player.item=="Sell")
   {      
      if(%player.hasItem==false)
      {
         say(%player,%player,"<f5>You do not have an item to sell.");
      }
      else
      {
         sellItem(%player);
         echo(%player@" "@getname(%player)@" sold item");
      }
   }
   else if(%player.item=="Follow")
   {
      order(%player.group,cloak,true);
      order(%player.group,guard,%vehicleId);
      say(%player,%player,"<f4>All of your AI vehicles have been ordered to guard you.");
   }
   else if(%player.item=="Guard")
   {
      if(getPosition(getVehicleNavMarkerId(%vehicleId))=="0.000000 0.000000 0.000000")
      {
         say(%player,%player,"<f5>You must first set a nav marker to specify a location for your AI vehicles to guard.");
      }
      else
      {
         %nav = getVehicleNavMarkerId(%vehicleId);
         %x = getposition(%nav,x);
         %y = getposition(%nav,y);
         %z = getTerrainHeight(%x,%y);
         order(%player.group,cloak,true);
         order(%player.group,guard,%x,%y,%z);
         say(%player,%player,"<f4>All of your AI vehicles have been ordered to guard your nav marker.");
      }
   }
   else if(%player.item=="Attack")
   {
      %target = getTargetId(%vehicleId);
      if((getTeam(%player)==getTeam(%target))&&($server::teamplay==true))
      {
         say(%player,%player,"<f5>You cannot order your AI vehicles to attack a teammate.");
      }
      else if(%target != "")
      {
         order(%player.group,cloak,true);
         order(%player.group,attack,%target);
         order(%player.turgroup, attack, 0);
         order(%player.turgroup, clear);
         say(%player,%player,"<f4>All of your AI vehicles have been ordered to attack your target.");
      }
      else
      {
         say(%player,%player,"<f5>You do not have an enemy targeted.");
      }
   }
}

echo("2000 2200");

function vehicle::onarrived(%vehicleId,%where)
{
   order(%vehicleId,cloak,true);
}

function useItem(%vehicleid)
{
   %player = playermanager::vehicleidtoplayernum(%vehicleid);
   %player.hasitem = false;
   if(%player.currentitem=="Field")
   {
      %field = copyObject($itemField);
      addToSet(%player.group,%field);
      setTeam(%field,getTeam(%vehicleId));
      %x = getposition(%vehicleId,x);
      %y = getposition(%vehicleId,y);
      %z = getposition(%vehicleId,z)-10;
      %rotRad = getPosition(%vehicleId,rot);
      %rotDeg = RadToDeg(%rotRad)+90;
      %rot = round(adjustAngle(%rotDeg));
      setPosition(%field,%x,%y,%z,%rot);
      say(%player,%player,"<f4>Energy Field Deployed","sfx_electrical_bzzt.wav");
      %player.currentitem = "";
   }
   else if(%player.currentitem=="Prox")
   {
      %tur = copyObject($itemSnaretur);
      setStaticShapeShortName(%tur,getName(%player)@"'s Snare.");
      addToSet(%player.turgroup, %tur);
      setHercOwner(%player.group, %player.group);
      setHercOwner(%player.group, %player.turgroup);
      setHercOwner(%player.group, %vehicleId);
      setTurretOwner(%player.turgroup, %player.turgroup);
      setTurretOwner(%player.turgroup, %player.group);
      setTurretOwner(%player.turgroup, %vehicleId);
      setTeam(%tur, getTeam(%vehicleId));
      %tur.owner = %player;
      %mine = copyObject($itemSnare);
      addToSet(%player.group,%mine);
      %mine.turret = %tur;
      %x = getposition(%vehicleId,x);
      %y = getposition(%vehicleId,y);
      %z = getTerrainHeight(%x,%y)+0.2;
      setPosition(%tur,%x,%y,%z-0.2);
      setPosition(%mine,%x,%y,%z);
      setTeam(%mine, getTeam(%vehicleId));
      %player.currentitem = "";
   }
   else if(%player.currentitem=="Stasis")
   {
      %field1 = copyObject($itemStasis);
      %field2 = copyObject($itemStasis);
      %field3 = copyObject($itemStasis);
      %field4 = copyObject($itemStasis);
      addToSet(%player.group,%field1);
      addToSet(%player.group,%field2);
      addToSet(%player.group,%field3);
      addToSet(%player.group,%field4);    
      %x = getposition(%vehicleId,x);
      %y = getposition(%vehicleId,y);
      %z1 = getTerrainHeight(%x,%y+30)+24;
      %z2 = getTerrainHeight(%x+30,%y)+24;
      %z3 = getTerrainHeight(%x,%y-30)+24;
      %z4 = getTerrainHeight(%x-30,%y)+24;
      setPosition(%field1,%x,%y+30,%z1,90,180);
      setPosition(%field2,%x+30,%y,%z2,0,180);
      setPosition(%field3,%x,%y-30,%z3,90,180);
      setPosition(%field4,%x-30,%y,%z4,0,180);
      say(%player,%player,"<f4>Protective stasis field deployed.","sfx_electrical_bzzt.wav");
      setHudTimer(0,-1,"",3,%player);
      setHudTimer(60,-1,"Stasis Field:",3,%player);
      schedule("deleteObject("@%field1@");",60);
      schedule("deleteObject("@%field2@");",60);
      schedule("deleteObject("@%field3@");",60);
      schedule("deleteObject("@%field4@");",60);
      %player.currentitem = "";
   }
}

echo("2400");

function sellItem(%player)
{
  if(%player.currentitem=="Prox")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.credits+=4;
      say(%player,%player,"<f4>You have sold your snare for 4 credits. You now have "@%player.credits@" credits.");
   }
   else if(%player.currentitem=="Stasis")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.credits+=5;
      say(%player,%player,"<f4>You have sold your stasis field for 5 credits. You now have "@%player.credits@" credits.");
   }
   else if(%player.currentitem=="Ion")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.credits+=6;
      say(%player,%player,"<f4>You have sold your ion cannon for 6 credits. You now have "@%player.credits@" credits.");
   }
   else if(%player.currentitem=="EMP")
   {
      %player.hasItem = false;
      %player.currentItem = "";
      %player.credits+=7;
      say(%player,%player,"<f4>You have sold your EMP shockwave generator for 7 credits. You now have "@%player.credits@" credits.");
   }
}

function trigger::onenter(%trigger,%vehicleid)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if(%name=="Ammo")
   {
      if(%player != 0)
      {
   	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_AMMOPAD, true, true);
         %player.InPad = true;
      }
   }
   else if(%name=="HealTrig")
   {
      if(%player != 0)
      {
     	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_HEALPAD, true, true);
         %player.InPad = true; 
      }
   }
   else if(%name=="Zen")
   {
      if(%player != 0)
      {
   	   Zen::onEnter(%trigger, %vehicleId, *IDMULT_CHAT_ALLPAD, true, true);
         %player.InPad = true; 
      }
   }
}

function trigger::onContact(%trigger,%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if((%name=="PROX")&&(%trigger.armed==true))
   {
      if(($antispawnkillProx==true)&&($server::teamplay==true)&&(%player.invincible==true))
      {
         echo(getname(%player)@" hit mine but was invincible");
      }
      else
      {
         %vehicleId.hitamine = true;
         %x = getposition(%trigger,x);
         %y = getposition(%trigger,y);
         %z = getposition(%trigger,z); 
         setPosition(%trigger.exp,%x,%y,%z);
         playAnimSequence(%trigger.exp,0,true);
         if(%player!=%trigger.owner)
         {
            %owner = %trigger.owner;
            if(($server::teamplay==true)&&(getTeam(%owner)==getTeam(%vehicleId)))
            {
               echo("PROX TEAMKILL - No points awarded");
            } 
            else if(%vehicleId.owner==%owner)
            {
               echo("PROX AI TEAMKILL - No points awarded");
            }
            else if(getTeam(%vehicleID) == *IDSTR_TEAM_NEUTRAL)
            {
               echo("PROX NEUTRAL DEFENDER KILL - No points awarded");
            }
            else
            {
               %owner.extraKills++;
               %owner.credits+=8;
            }
            say(0,5,getHudName(%vehicleId)@" stepped on one of "@getName(%trigger.owner)@"'s mines!");
         }
         else
         {
            say(0,5,getHudName(%vehicleId)@" accidentally stepped on one of his own mines!");
         }
         resetLastHitBy(%vehicleId);
         healObject(%vehicleId,-50000);
         playSound(0,"sfx_fog.wav",IDPRF_2D);
         schedule("proxFix("@%trigger@");",0.5);
         setposition(%trigger,0,0,-1000);
         setposition(%trigger.mine,0,0,-1000);
         schedule("deleteObject("@%trigger@");",1.067);
         schedule("deleteObject("@%trigger.mine@");",1.067);
         schedule("deleteObject("@%trigger.exp@");",1.067);
      }
   }
   else if(%name=="Ammo")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 0, 40, 40, true); 
      }
      else
      {
         reloadObject(%vehicleid,50000);
      }
   }
   else if(%name=="HealTrig")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 1000, 0, 0, true); 
      }
      else
      {
         healObject(%vehicleid,400);
      }
   }
   else if(%name=="Zen")
   {
      if(%player != 0)
      {
         Zen::work(%trigger, %vehicleid, 1000, 40, 70, true); 
      }
      else
      {
         healObject(%vehicleid,400);
         reloadObject(%vehicleid,50000);
      }
   }
}

function proxFix(%trigger)
{
   %trigger.owner = "";
}

function trigger::onLeave(%trigger,%vehicleid)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %name = getobjectname(%trigger);
   if((%name=="Ammo")||(%name=="HealTrig")||(%name=="Zen"))
   {
      %player.InPad = false;
   }
}

function onMissionEnd()
{
   flushConsoleScheduler();
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getPlayerNum(%i);
      deleteObject(%player.group);
      %player.group = "";
   }
}

function deployItem::trigger::onContact(%trigger, %vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   if(%player!=0)
   {
      if(isshutdown(%vehicleId) == false)
      {
         %player.justlaid = false;
      }
      if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.hasItem == true)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
         useItem(%vehicleId);
      }  
      else if((%player.InPad == false)&&(isshutdown(%vehicleId) == true)&&(%player.hasItem == false)&&(%player.justlaid == false)&&(%player.deathdelay == false))
      {  
         %player.justlaid = true;
         say(%player,%player, "<f5>You do not have a deployable item.");
      }
   }
}

echo("2600");

function cleanUpDeadTurrets()
{
   for(%i=2049;%i<2100;%i++)
   {
      if((getConnection(%i)=="")&&(getObjectName(%i.group)!=False))
      {
         deleteObject(%i.group);
         %i.group = "";
      }
   }
   echo("NOTE: This is normal. Ignore the error messages.");
   %num=0;
   for(%i=8000; %i<10000; %i++)
   {
      if((strAlign(3,l,getObjectName(%i))=="tur")&&(isGroupDestroyed(%i)==true)&&(%i!=$turHATC)&&(%i!=$turEMP)&&(%i!=$turHLAS)&&(%i!=$turHBLAS)&&(%i!=$turHBC)&&(%i!=$turBLINK)&&(%i!=$turELF)&&(%i!=$turMFAC)&&(%i!=$turNIKE)&&(%i!=$turPBW))
      {
         %i.owner = "";
         deleteObject(%i);
         %num++;
      }
   }
   if(%num!=0)
   {
      echo("CLEANUP REPORT: Found "@%num@" loose turrets. Deleting the leftovers now.");
   }
   schedule("cleanUpDeadTurrets();",300);
}

function structure::ondestroyed(%destroyed,%destroyer)
{
   if(getObjectName(%destroyed)=="Field")
   {
      schedule("deleteObject("@%destroyed@");",1);
   }
}

function getCredits(%player)
{
   return %player.credits;
}

function getAllKills(%player)
{
   return(getKills(%player) + %player.extraKills);
}

function getPlayerScore(%a)
{
   return((getAllKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints));
}

function getAllTeamKills(%a)
{
   return(getTeamKills(%a) + getExtraTeamKills(%a));
}

function getTeamScore(%a)
{
   return((getAllTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints));
}

function getExtraTeamKills(%a)
{
   %index0 = "Yellow Team";
   %index1 = "Blue Team";
   %index2 = "Red Team";
   %index3 = "Purple Team";
   %teamIndex = getTeamColorFromBits(%a);
   %color = %index[%teamindex];
   %teamExtraKills = 0;
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      if(getTeam(%player)==%color)
      {
         %teamExtraKills += %player.extrakills;
      }
   }
   return %teamExtraKills;
}

function getAIcount(%player)
{
   return %Player.aicount;
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
	   $ScoreBoard::PlayerColumnHeader2 = "Credits";
	   $ScoreBoard::PlayerColumnHeader3 = "Score";
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
	   $ScoreBoard::PlayerColumnHeader6 = "AI Count";
	   $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
	   $ScoreBoard::PlayerColumnFunction2 = "getCredits";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
	   $ScoreBoard::PlayerColumnFunction6 = "getAIcount";
	   $ScoreBoard::PlayerColumnFunction7 = "getSquad";
   }
   else
   {
       // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader2 = "Credits";
	   $ScoreBoard::PlayerColumnHeader3 = "Score";
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
	   $ScoreBoard::PlayerColumnHeader6 = "AI Count";

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getCredits";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getAllKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
	   $ScoreBoard::PlayerColumnFunction6 = "getAIcount";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getAllTeamKills";
   $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

function RadToDeg(%radians)
{
   %degrees = (%radians * 180) / 3.14159;
   return %degrees;
}

function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}

function adjustAngle(%angle)
{
   if(%angle >= 360)
   {
      while(%angle >= 360)
      {
         %angle = (%angle - 360);
      }
   }
   else if(%angle < 0)
   {
      while(%angle < 0)
      {
         %angle = (%angle + 360);
      }
   }
   return %angle;
}

echo("2800");

// Free Credits Easter Egg Function (For overly generous hosts)
// TYPE: focusserver();freeCredits(50);focusclient();

function freeCredits(%amount)
{
   if(%amount=="")
   {
      %amount = 50;
   }
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      %player.credits+=%amount;
   } 
}

function frosty::structure::onscan(%this, %v){
 if($scandelay == true){ return; }
 freeCredits(5);
 damageobject(%v,100000);
 $scandelay = true;
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 %player.credits = %player.credits + 10;
 %x = randomint(-6000, 6000);
 %y = randomint(-7000, 2000);
 setposition(%this, %x, %y, getterrainheight(%x, %y));
 order($nexus1, guard, %v);
 order($nexus2, guard, %v);
 order($nexus3, guard, %v);
 order($nexus4, guard, %v);
 schedule("$scandelay = false;", 5); }

//Set all player credits to one amount
//Use as above
function setCredits(%amount)
{
   if(%amount=="")
   {
      %amount = 30;
   }
   %count = playermanager::getplayercount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getplayernum(%i);
      %player.credits = %amount;
   } 
}

function ghost::vehicle::onattacked(%v,%w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 reloadobject(%v, 1000);
 healobject(%v, 200);
 healobject(%w, -100); }

function glitchchicken::vehicle::onattacked(%v,%w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 reloadobject(%v, 1000);
 healobject(%v, 200); }

function glitchdogpile::vehicle::onattacked(%v,%w){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){ return; }
 healobject(%v, 200); }

function Kinetron::trigger::oncontact(%this,%object){
 if(getPosition(getVehicleNavMarkerId(%object))=="0.000000 0.000000 0.000000")
 { setposition(%object, (6000 + randomInt(-5,5)), 1000, 500); }
 else{ warp(%object, getVehicleNavMarkerId(%object)); } }
 
function Kinetron::structure::onscan(%this,%scanner){
 %player = playermanager::vehicleIdtoPlayerNum(%scanner);
 if(%this.owner != %player){
  say(%player,0,"<F4>Unauthorized user!","alarm2.wav");
  damageobject(%scanner, 1000);
  return; }
 if(getPosition(getVehicleNavMarkerId(%scanner))=="0.000000 0.000000 0.000000")
 { setposition(%object, (6000 + randomInt(-5,5)), 1000, 500); }
 else{ warp(%scanner, getVehicleNavMarkerId(%scanner)); } }

function Snare::structure::onDestroyed(%this,%object){ deleteObject(%this.turret); }

//
